// ******************************************************************
// *
// *    .,-:::::    .,::      .::::::::.    .,::      .:
// *  ,;;;'````'    `;;;,  .,;;  ;;;'';;'   `;;;,  .,;; 
// *  [[[             '[[,,[['   [[[__[[\.    '[[,,[['  
// *  $$$              Y$$$P     $$""""Y$$     Y$$$P    
// *  `88bo,__,o,    oP"``"Yo,  _88o,,od8P   oP"``"Yo,  
// *    "YUMMMMMP",m"       "Mm,""YUMMMP" ,m"       "Mm,
// *
// *   Cxbx->Win32->XBVideo.cpp
// *
// *  This file is part of the Cxbx project.
// *
// *  Cxbx and Cxbe are free software; you can redistribute them
// *  and/or modify them under the terms of the GNU General Public
// *  License as published by the Free Software Foundation; either
// *  version 2 of the license, or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2003 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************
// ******************************************************************
// *
// *    .,-:::::    .,::      .::::::::.    .,::      .:
// *  ,;;;'````'    `;;;,  .,;;  ;;;'';;'   `;;;,  .,;; 
// *  [[[             '[[,,[['   [[[__[[\.    '[[,,[['  
// *  $$$              Y$$$P     $$""""Y$$     Y$$$P    
// *  `88bo,__,o,    oP"``"Yo,  _88o,,od8P   oP"``"Yo,  
// *    "YUMMMMMP",m"       "Mm,""YUMMMP" ,m"       "Mm,
// *
// *   Cxbx->Win32->Cxbx->XBVideo.h
// *
// *  This file is part of the Cxbx project.
// *
// *  Cxbx and Cxbe are free software; you can redistribute them
// *  and/or modify them under the terms of the GNU General Public
// *  License as published by the Free Software Foundation; either
// *  version 2 of the license, or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2003 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************


// ******************************************************************
// * class: XBVideo
// ******************************************************************
public class XBVideo extends Error
{
		// ******************************************************************
		// * Initialization
		// ******************************************************************

		// ******************************************************************
		// * func: XBVideo::XBVideo
		// ******************************************************************
		public XBVideo()
		{
			this.m_bVSync = false;
			this.m_bFullscreen = false;
			m_szVideoResolution = "Automatic (Default)";
		}

	   // ******************************************************************
	   // * func: XBVideo::~XBVideo
	   // ******************************************************************
	   public void dispose()
	   {
		   super.dispose();
	   }

		// ******************************************************************
		// * Registry Load/Save
		// ******************************************************************

		// ******************************************************************
		// * func: XBVideo::Load
		// ******************************************************************
		public final void Load(String szRegistryKey)
		{
			// ******************************************************************
			// * Load Configuration from Registry
			// ******************************************************************
			{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: DWORD dwDisposition, dwType, dwSize;
				int dwDisposition;
				int dwType;
				int dwSize;
				HKEY hKey = new HKEY();

				if (RegCreateKeyEx(HKEY_CURRENT_USER, szRegistryKey, 0, null, REG_OPTION_NON_VOLATILE, KEY_QUERY_VALUE, null, hKey, dwDisposition) == ERROR_SUCCESS)
				{
					int v = 0;

					dwType = REG_SZ;
					dwSize = 100;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegQueryValueEx(hKey, "VideoResolution", NULL, &dwType, (PBYTE)m_szVideoResolution, &dwSize);
					RegQueryValueEx(hKey, "VideoResolution", null, dwType, (byte)m_szVideoResolution, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegQueryValueEx(hKey, "DisplayAdapter", NULL, &dwType, (PBYTE)&m_dwDisplayAdapter, &dwSize);
					RegQueryValueEx(hKey, "DisplayAdapter", null, dwType, (byte) & m_dwDisplayAdapter, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegQueryValueEx(hKey, "Direct3DDevice", NULL, &dwType, (PBYTE)&m_dwDirect3DDevice, &dwSize);
					RegQueryValueEx(hKey, "Direct3DDevice", null, dwType, (byte) & m_dwDirect3DDevice, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegQueryValueEx(hKey, "Fullscreen", NULL, &dwType, (PBYTE)&m_bFullscreen, &dwSize);
					RegQueryValueEx(hKey, "Fullscreen", null, dwType, (byte) & m_bFullscreen, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegQueryValueEx(hKey, "VSync", NULL, &dwType, (PBYTE)&m_bVSync, &dwSize);
					RegQueryValueEx(hKey, "VSync", null, dwType, (byte) & m_bVSync, dwSize);

					RegCloseKey(hKey);
				}
			}
		}

		// ******************************************************************
		// * func: XBVideo::Save
		// ******************************************************************
		public final void Save(String szRegistryKey)
		{
			// ******************************************************************
			// * Save Configuration to Registry
			// ******************************************************************
			{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: DWORD dwDisposition, dwType, dwSize;
				int dwDisposition;
				int dwType;
				int dwSize;
				HKEY hKey = new HKEY();

				if (RegCreateKeyEx(HKEY_CURRENT_USER, szRegistryKey, 0, null, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, null, hKey, dwDisposition) == ERROR_SUCCESS)
				{
					int v = 0;

					dwType = REG_SZ;
					dwSize = 100;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegSetValueEx(hKey, "VideoResolution", 0, dwType, (PBYTE)m_szVideoResolution, dwSize);
					RegSetValueEx(hKey, "VideoResolution", 0, dwType, (byte)m_szVideoResolution, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegSetValueEx(hKey, "DisplayAdapter", 0, dwType, (PBYTE)&m_dwDisplayAdapter, dwSize);
					RegSetValueEx(hKey, "DisplayAdapter", 0, dwType, (byte) & m_dwDisplayAdapter, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegSetValueEx(hKey, "Direct3DDevice", 0, dwType, (PBYTE)&m_dwDirect3DDevice, dwSize);
					RegSetValueEx(hKey, "Direct3DDevice", 0, dwType, (byte) & m_dwDirect3DDevice, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegSetValueEx(hKey, "Fullscreen", 0, dwType, (PBYTE)&m_bFullscreen, dwSize);
					RegSetValueEx(hKey, "Fullscreen", 0, dwType, (byte) & m_bFullscreen, dwSize);

					dwType = REG_DWORD;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: dwSize = sizeof(DWORD);
					dwSize = Integer.SIZE;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: RegSetValueEx(hKey, "VSync", 0, dwType, (PBYTE)&m_bVSync, dwSize);
					RegSetValueEx(hKey, "VSync", 0, dwType, (byte) & m_bVSync, dwSize);

					RegCloseKey(hKey);
				}
			}
		}

		// ******************************************************************
		// * SetDirect3DDevice
		// ******************************************************************
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: void SetDirect3DDevice(DWORD dwDirect3DDevice)
		public final void SetDirect3DDevice(int dwDirect3DDevice)
		{
			m_dwDirect3DDevice = dwDirect3DDevice;
		}
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: DWORD GetDirect3DDevice()
		public final int GetDirect3DDevice()
		{
			return m_dwDirect3DDevice;
		}

		// ******************************************************************
		// * SetDisplayAdapter
		// ******************************************************************
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: void SetDisplayAdapter(DWORD dwDisplayAdapter)
		public final void SetDisplayAdapter(int dwDisplayAdapter)
		{
			m_dwDisplayAdapter = dwDisplayAdapter;
		}
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: DWORD GetDisplayAdapter()
		public final int GetDisplayAdapter()
		{
			return m_dwDisplayAdapter;
		}

		// ******************************************************************
		// * SetVideoResolution
		// ******************************************************************
		public final void SetVideoResolution(String szBuffer)
		{
			m_szVideoResolution = szBuffer;
		}
		public final String GetVideoResolution()
		{
			return m_szVideoResolution;
		}

		// ******************************************************************
		// * Fullscreen Toggling
		// ******************************************************************
		public final void SetFullscreen(int bFullscreen)
		{
			m_bFullscreen = bFullscreen;
		}
		public final int GetFullscreen()
		{
			return m_bFullscreen;
		}

		// ******************************************************************
		// * VSync Toggling
		// ******************************************************************
		public final void SetVSync(int bVSync)
		{
			m_bVSync = bVSync;
		}
		public final int GetVSync()
		{
			return m_bVSync;
		}

		// ******************************************************************
		// * Configuration
		// ******************************************************************
		private String m_szVideoResolution = new String(new char[100]);
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: DWORD m_dwDisplayAdapter;
		private int m_dwDisplayAdapter;
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: DWORD m_dwDirect3DDevice;
		private int m_dwDirect3DDevice;
		private int m_bFullscreen;
		private int m_bVSync;
}


final class DefineConstants
{
//C++ TO JAVA CONVERTER TODO TASK: The following #define constant was defined in different ways:
	public static final String _CXBX_VERSION = "0.8.0";
	public static final String _CXBX_VERSION = "0.8.0-Trace";
	public static final int MAXIMUM_XBOX_THREADS = 256;
}