// ******************************************************************
// *
// *    .,-:::::    .,::      .::::::::.    .,::      .:
// *  ,;;;'````'    `;;;,  .,;;  ;;;'';;'   `;;;,  .,;; 
// *  [[[             '[[,,[['   [[[__[[\.    '[[,,[['  
// *  $$$              Y$$$P     $$""""Y$$     Y$$$P    
// *  `88bo,__,o,    oP"``"Yo,  _88o,,od8P   oP"``"Yo,  
// *    "YUMMMMMP",m"       "Mm,""YUMMMP" ,m"       "Mm,
// *
// *   Cxbx->Core->Xbe.cpp
// *
// *  This file is part of the Cxbx project.
// *
// *  Cxbx and Cxbe are free software; you can redistribute them
// *  and/or modify them under the terms of the GNU General Public
// *  License as published by the Free Software Foundation; either
// *  version 2 of the license, or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2003 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************
// ******************************************************************
// *
// *    .,-:::::    .,::      .::::::::.    .,::      .:
// *  ,;;;'````'    `;;;,  .,;;  ;;;'';;'   `;;;,  .,;; 
// *  [[[             '[[,,[['   [[[__[[\.    '[[,,[['  
// *  $$$              Y$$$P     $$""""Y$$     Y$$$P    
// *  `88bo,__,o,    oP"``"Yo,  _88o,,od8P   oP"``"Yo,  
// *    "YUMMMMMP",m"       "Mm,""YUMMMP" ,m"       "Mm,
// *
// *   Cxbx->Core->Xbe.h
// *
// *  This file is part of the Cxbx project.
// *
// *  Cxbx and Cxbe are free software; you can redistribute them
// *  and/or modify them under the terms of the GNU General Public
// *  License as published by the Free Software Foundation; either
// *  version 2 of the license, or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2003 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************



// Xbe (Xbox Executable) file object
public class Xbe extends Error
{
		// construct via Xbe file

		// construct via Xbe file
		public Xbe(String x_szFilename)
		{
			String szBuffer = new String(new char[260]);

			ConstructorInit();

			System.out.print("Xbe::Xbe: Opening Xbe file...");

			FILE XbeFile = fopen(x_szFilename, "rb");

			// verify Xbe file was opened successfully
			if (XbeFile == 0)
			{
				SetError("Could not open Xbe file.", true);
				return;
			}

			System.out.print("OK\n");

			{
			// remember the Xbe path
				System.out.print("Xbe::Xbe: Storing Xbe Path...");

				m_szPath = x_szFilename;

				int v = 0;
				int c = 0;

				while (m_szPath.charAt(v) != '\0')
				{
					if (m_szPath.charAt(v) == '\\')
					{
						c = v + 1;
					}
					v++;
				}

				m_szPath = tangible.StringFunctions.changeCharacter(m_szPath, c, '\0');
			}

			System.out.print("OK\n");

			{
			// read Xbe image header
				System.out.print("Xbe::Xbe: Reading Image Header...");

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				if (fread(m_Header, sizeof(m_Header), 1, XbeFile) != 1)
				{
					SetError("Unexpected end of file while reading Xbe Image Header", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: if(m_Header.dwMagic != *(unsigned long *)"XBEH")
				if (m_Header.dwMagic != (int)"XBEH")
				{
					SetError("Invalid magic number in Xbe file", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				System.out.print("OK\n");
			}

			// read Xbe image header extra bytes
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
			if (m_Header.dwSizeofHeaders > sizeof(m_Header))
			{
				System.out.print("Xbe::Xbe: Reading Image Header Extra Bytes...");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long ExSize = RoundUp(m_Header.dwSizeofHeaders, 0x1000) - sizeof(m_Header);
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				int ExSize = GlobalMembers.RoundUp(m_Header.dwSizeofHeaders, 0x1000) - sizeof(m_Header);

				m_HeaderEx = new String(new char[ExSize - 1]);

				if (fread(m_HeaderEx, ExSize, 1, XbeFile) != 1)
				{
					SetError("Unexpected end of file while reading Xbe Image Header (Ex)", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				System.out.print("OK\n");
			}

			{
			// read Xbe certificate
				System.out.print("Xbe::Xbe: Reading Certificate...");

				fseek(XbeFile, m_Header.dwCertificateAddr - m_Header.dwBaseAddr, SEEK_SET);

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				if (fread(m_Certificate, sizeof(m_Certificate), 1, XbeFile) != 1)
				{
					SetError("Unexpected end of file while reading Xbe Certificate", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				setlocale(LC_ALL, "English");

				wcstombs(m_szAsciiTitle, m_Certificate.wszTitleName, 40);

				System.out.print("OK\n");

				System.out.printf("Xbe::Xbe: Title identified as %s\n", m_szAsciiTitle);
			}

			{
			// read Xbe section headers
				System.out.print("Xbe::Xbe: Reading Section Headers...\n");

				fseek(XbeFile, m_Header.dwSectionHeadersAddr - m_Header.dwBaseAddr, SEEK_SET);

				m_SectionHeader = tangible.Arrays.initializeWithDefaultSectionHeaderInstances(m_Header.dwSections);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
				for (int v = 0;v < m_Header.dwSections;v++)
				{
					System.out.printf("Xbe::Xbe: Reading Section Header 0x%.04X...", v);

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					if (fread(m_SectionHeader[v], sizeof(m_SectionHeader), 1, XbeFile) != 1)
					{
						szBuffer = String.format("Unexpected end of file while reading Xbe Section Header %d (%Xh)", v, v);
						SetError(szBuffer, true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					System.out.print("OK\n");
				}
			}

			{
			// read Xbe section names
				System.out.print("Xbe::Xbe: Reading Section Names...\n");

				m_szSectionName = new String(new char[m_Header.dwSections - 1])[9];
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
				for (int v = 0;v < m_Header.dwSections;v++)
				{
					System.out.printf("Xbe::Xbe: Reading Section Name 0x%.04X...", v);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned char *sn = GetAddr(m_SectionHeader[v].dwSectionNameAddr);
					byte[] sn = GetAddr(m_SectionHeader[v].dwSectionNameAddr);

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
					memset(m_szSectionName.charAt(v), 0, 9);

					if (sn != 0)
					{
						for (int b = 0;b < 8;b++)
						{
							m_szSectionName.charAt(v)[b] = sn[b];

							if (m_szSectionName.charAt(v)[b] == '\0')
							{
								break;
							}
						}
					}

					System.out.printf("OK (%s)\n", m_szSectionName.charAt(v));
				}
			}

			// read Xbe library versions
			if (m_Header.dwLibraryVersionsAddr != 0)
			{
				System.out.print("Xbe::Xbe: Reading Library Versions...\n");

				fseek(XbeFile, m_Header.dwLibraryVersionsAddr - m_Header.dwBaseAddr, SEEK_SET);

				m_LibraryVersion = tangible.Arrays.initializeWithDefaultLibraryVersionInstances(m_Header.dwLibraryVersions);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwLibraryVersions;v++)
				for (int v = 0;v < m_Header.dwLibraryVersions;v++)
				{
					System.out.printf("Xbe::Xbe: Reading Library Version 0x%.04X...", v);

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					if (fread(m_LibraryVersion[v], sizeof(m_LibraryVersion), 1, XbeFile) != 1)
					{
						szBuffer = String.format("Unexpected end of file while reading Xbe Library Version %d (%Xh)", v, v);
						SetError(szBuffer, true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					System.out.print("OK\n");
				}

				{
				// read Xbe kernel library version
					System.out.print("Xbe::Xbe: Reading Kernel Library Version...");

					if (m_Header.dwKernelLibraryVersionAddr == 0)
					{
						SetError("Could not locate kernel library version", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					fseek(XbeFile, m_Header.dwKernelLibraryVersionAddr - m_Header.dwBaseAddr, SEEK_SET);

					m_KernelLibraryVersion = new LibraryVersion();

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					if (fread(m_KernelLibraryVersion, sizeof(m_LibraryVersion), 1, XbeFile) != 1)
					{
						SetError("Unexpected end of file while reading Xbe Kernel Version", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					System.out.print("OK\n");
				}

				{
				// read Xbe Xapi library version
					System.out.print("Xbe::Xbe: Reading Xapi Library Version...");

					if (m_Header.dwXAPILibraryVersionAddr == 0)
					{
						SetError("Could not locate Xapi Library Version", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					fseek(XbeFile, m_Header.dwXAPILibraryVersionAddr - m_Header.dwBaseAddr, SEEK_SET);

					m_XAPILibraryVersion = new LibraryVersion();

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					if (fread(m_XAPILibraryVersion, sizeof(m_LibraryVersion), 1, XbeFile) != 1)
					{
						SetError("Unexpected end of file while reading Xbe Xapi Version", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					System.out.print("OK\n");
				}
			}

			{
			// read Xbe sections
				System.out.print("Xbe::Xbe: Reading Sections...\n");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: m_bzSection = new unsigned char*[m_Header.dwSections];
				m_bzSection = new byte[m_Header.dwSections][];

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
				memset(m_bzSection, 0, m_Header.dwSections);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
				for (int v = 0;v < m_Header.dwSections;v++)
				{
					System.out.printf("Xbe::Xbe: Reading Section 0x%.04X...", v);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long RawSize = m_SectionHeader[v].dwSizeofRaw;
					int RawSize = m_SectionHeader[v].dwSizeofRaw;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long RawAddr = m_SectionHeader[v].dwRawAddr;
					int RawAddr = m_SectionHeader[v].dwRawAddr;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: m_bzSection[v] = new unsigned char[RawSize];
					m_bzSection[v] = new byte[RawSize];

					fseek(XbeFile, RawAddr, SEEK_SET);

					if (RawSize == 0)
					{
						System.out.print("OK\n");
						continue;
					}

					if (fread(m_bzSection[v], RawSize, 1, XbeFile) != 1)
					{
						szBuffer = String.format("Unexpected end of file while reading Xbe Section %d (%Xh) (%s)", v, v, m_szSectionName.charAt(v));
						SetError(szBuffer, true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					System.out.print("OK\n");
				}
			}

			// read Xbe thread local storage
			if (m_Header.dwTLSAddr != 0)
			{
				System.out.print("Xbe::Xbe: Reading Thread Local Storage...");

				Object Addr = GetAddr(m_Header.dwTLSAddr);

				if (Addr == 0)
				{
					SetError("Could not locate Thread Local Storage", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				m_TLS = new TLS();

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memcpy' has no equivalent in Java:
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				memcpy(m_TLS, Addr, sizeof(m_TLS));

				System.out.print("OK\n");
			}

//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
		cleanup:

			if (GetError() != 0)
			{
				System.out.print("FAILED!\n");
				System.out.printf("Xbe::Xbe: ERROR -> %s\n", GetError());
			}

			fclose(XbeFile);

			return;
		}

		// construct via Exe file object

		// construct via Exe file object
		public Xbe(Exe x_Exe, String x_szTitle, boolean x_bRetail)
		{
			ConstructorInit();

			time_t CurrentTime = new time_t();

			time(CurrentTime);

			System.out.print("Xbe::Xbe: Pass 1 (Simple Pass)...");

			{
			// pass 1
				// standard Xbe magic number
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: m_Header.dwMagic = *(unsigned long*)"XBEH";
				m_Header.dwMagic = (int)"XBEH";

				// nobody has the private key yet, so zero this out
//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
				memset(m_Header.pbDigitalSignature, 0, 256);

				// we'll only allow 0x00010000 for now
				m_Header.dwBaseAddr = 0x00010000;

				// this is a constant value
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				m_Header.dwSizeofImageHeader = sizeof(m_Header);

				// we'll have the same number of sections as the Exe
				m_Header.dwSections = x_Exe.m_Header.m_sections;

				{
				// TODO: allow configuration
//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					memset(m_Header.dwInitFlags, 0, sizeof(m_Header.dwInitFlags));

					m_Header.dwInitFlags.bLimit64MB = true;
					m_Header.dwInitFlags.bDontSetupHarddisk = false;
					m_Header.dwInitFlags.bMountUtilityDrive = true;
				}

				{
				// various PE copies
					m_Header.dwPeStackCommit = 0x00010000; //x_Exe->m_OptionalHeader.m_sizeof_stack_commit;
					m_Header.dwPeHeapReserve = x_Exe.m_OptionalHeader.m_sizeof_heap_reserve;
					m_Header.dwPeHeapCommit = x_Exe.m_OptionalHeader.m_sizeof_heap_commit;
					m_Header.dwPeSizeofImage = x_Exe.m_OptionalHeader.m_sizeof_image;
					m_Header.dwPeChecksum = 0x00000000;
					m_Header.dwPeTimeDate = x_Exe.m_Header.m_timedate;
				}

				// build time/date
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: m_Header.dwTimeDate = (unsigned long)CurrentTime;
				m_Header.dwTimeDate = (int)CurrentTime;

				// TODO: generate valid addr if necessary
				m_Header.dwNonKernelImportDirAddr = 0;

				// TODO: generate these values
				m_Header.dwLibraryVersions = 0;
				m_Header.dwLibraryVersionsAddr = 0;
				m_Header.dwKernelLibraryVersionAddr = 0;
				m_Header.dwXAPILibraryVersionAddr = 0;
			}

			System.out.print("OK\n");

			System.out.print("Xbe::Xbe: Pass 2 (Calculating Requirements)...");

			{
			// pass 2
				// make-room cursor
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long mrc = m_Header.dwBaseAddr + sizeof(m_Header);
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				int mrc = m_Header.dwBaseAddr + sizeof(m_Header);

				{
				// make room for certificate
					m_Header.dwCertificateAddr = mrc;

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					mrc += sizeof(m_Certificate);
				}

				{
				// make room for section headers
					m_Header.dwSectionHeadersAddr = mrc;

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					mrc += m_Header.dwSections * (sizeof(m_SectionHeader));

					// make room for head/tail reference count words
					mrc += (m_Header.dwSections + 1) * 2;

					// make room for section names
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
					for (int v = 0;v < m_Header.dwSections;v++)
					{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long s = 0;
						int s = 0;

						while (s < 8 && x_Exe.m_SectionHeader[v].m_name[s] != '\0')
						{
							s++;
						}

						mrc += s + 1;
					}
				}

				{
				// TODO: make room for library versions
				}

				{
				// make room for debug path / debug file names
					// TODO: allow this to be configured, right now we will just null out these values
					m_Header.dwDebugUnicodeFilenameAddr = mrc;
					m_Header.dwDebugPathnameAddr = mrc;
					m_Header.dwDebugFilenameAddr = mrc;

					mrc += 2;
				}

				{
				// make room for largest possible logo bitmap
					mrc = GlobalMembers.RoundUp(mrc, 0x10);

					m_Header.dwLogoBitmapAddr = mrc;
					m_Header.dwSizeofLogoBitmap = 100 * 17; // Max Possible

					mrc += m_Header.dwSizeofLogoBitmap;
				}

				// update size of headers
				m_Header.dwSizeofHeaders = mrc - m_Header.dwBaseAddr;
			}

			System.out.print("OK\n");

			System.out.print("Xbe::Xbe: Pass 3 (Generating Xbe)...\n");

			{
			// pass 3
				m_Header.dwPeBaseAddr = m_Header.dwBaseAddr + GlobalMembers.RoundUp(m_Header.dwSizeofHeaders, 0x1000) - x_Exe.m_SectionHeader[0].m_virtual_addr;

				{
				// encode entry point
					System.out.printf("Xbe::Xbe: Encoding %s Entry Point...", x_bRetail?"Retail":"Debug");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long ep = x_Exe->m_OptionalHeader.m_entry + m_Header.dwPeBaseAddr;
					int ep = x_Exe.m_OptionalHeader.m_entry + m_Header.dwPeBaseAddr;

					if (x_bRetail)
					{
						ep ^= GlobalMembers.XOR_EP_RETAIL;
					}
					else
					{
						ep ^= GlobalMembers.XOR_EP_DEBUG;
					}

					m_Header.dwEntryAddr = ep;

					System.out.printf("OK (0x%.08X)\n", ep);
				}

				// header write cursor
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long hwc = m_Header.dwBaseAddr + sizeof(m_Header);
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				int hwc = m_Header.dwBaseAddr + sizeof(m_Header);

				// check if we need to store extra header bytes (we always will)
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				if (m_Header.dwSizeofHeaders > sizeof(m_Header))
				{
					System.out.print("Xbe::Xbe: Found Extra Header Bytes...");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long ExSize = RoundUp(m_Header.dwSizeofHeaders - sizeof(m_Header), 0x1000);
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					int ExSize = GlobalMembers.RoundUp(m_Header.dwSizeofHeaders - sizeof(m_Header), 0x1000);

					m_HeaderEx = new String(new char[ExSize - 1]);

					System.out.print("OK\n");
				}

				// start a write buffer inside of m_HeaderEx
//C++ TO JAVA CONVERTER TODO TASK: Pointer arithmetic is detected on this variable, so pointers on this variable are left unchanged:
				byte * szBuffer = m_HeaderEx;

				{
				// write certificate
					// certificate size is a constant
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					m_Certificate.dwSize = sizeof(m_Certificate);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: m_Certificate.dwTimeDate = (unsigned long)CurrentTime;
					m_Certificate.dwTimeDate = (int)CurrentTime;

					// TODO: generate in the form CX-9999
					m_Certificate.dwTitleId = (int)0xFFFF0002;

					// title name
//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
					memset(m_Certificate.wszTitleName, 0, 40);
					mbstowcs(m_Certificate.wszTitleName, x_szTitle, 40);

					{
					// zero out alternate ids
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long c=0;c<0x10;c++)
						for (int c = 0;c < 0x10;c++)
						{
							m_Certificate.dwAlternateTitleId[c] = 0;
						}
					}

					// for now we'll just allow any media you could want
					m_Certificate.dwAllowedMedia = GlobalMembers.XBEIMAGE_MEDIA_TYPE_HARD_DISK | GlobalMembers.XBEIMAGE_MEDIA_TYPE_DVD_CD | GlobalMembers.XBEIMAGE_MEDIA_TYPE_MEDIA_BOARD;

					// TODO: allow configuration
					m_Certificate.dwGameRegion = GlobalMembers.XBEIMAGE_GAME_REGION_MANUFACTURING | GlobalMembers.XBEIMAGE_GAME_REGION_NA | GlobalMembers.XBEIMAGE_GAME_REGION_JAPAN | GlobalMembers.XBEIMAGE_GAME_REGION_RESTOFWORLD;

					// TODO: allow configuration
					m_Certificate.dwGameRatings = (int)0xFFFFFFFF;

					// always disk 0, AFAIK
					m_Certificate.dwDiskNumber = 0;

					// TODO: allow configuration
					m_Certificate.dwVersion = 0;

					{
					// generate blank LAN, signature, and alternate signature keys
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<0x10;v++)
						for (int v = 0;v < 0x10;v++)
						{
							m_Certificate.bzLanKey[v] = m_Certificate.bzSignatureKey[v] = 0;
						}

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long x=0;x<0x10;x++)
						for (int x = 0;x < 0x10;x++)
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long y=0;y<0x10;y++)
						{
							for (int y = 0;y < 0x10;y++)
							{
								m_Certificate.bzTitleAlternateSignatureKey[x][y] = 0;
							}
						}

					}

					{
					// write certificate
//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memcpy' has no equivalent in Java:
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
						memcpy(szBuffer, m_Certificate, sizeof(m_Certificate));

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
						szBuffer += sizeof(m_Certificate);

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
						hwc += sizeof(m_Certificate);
					}
				}

				// generate ascii title from certificate title name
				setlocale(LC_ALL, "English");
				wcstombs(m_szAsciiTitle, m_Certificate.wszTitleName, 40);

				{
				// write section headers / section names
					m_szSectionName = new String(new char[m_Header.dwSections - 1])[9];

					m_SectionHeader = tangible.Arrays.initializeWithDefaultSectionHeaderInstances(m_Header.dwSections);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long SectionCursor = RoundUp(m_Header.dwSizeofHeaders, 0x1000);
					int SectionCursor = GlobalMembers.RoundUp(m_Header.dwSizeofHeaders, 0x1000);

					// head/tail reference count write buffer
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned short *htrc = (unsigned short*)(szBuffer + m_Header.dwSections*sizeof(*m_SectionHeader));
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					short[] htrc = (short)(szBuffer + m_Header.dwSections * sizeof(m_SectionHeader));

					// section write buffer
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: char *secn = (char*)((unsigned long)htrc + (m_Header.dwSections+1)*2);
					byte[] secn = (String)((int)htrc + (m_Header.dwSections + 1) * 2);

					// head/tail reference count write cursor
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long hwc_htrc = hwc + m_Header.dwSections*sizeof(*m_SectionHeader);
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					int hwc_htrc = hwc + m_Header.dwSections * sizeof(m_SectionHeader);

					// section write cursor
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long hwc_secn = hwc_htrc + (m_Header.dwSections+1)*2;
					int hwc_secn = hwc_htrc + (m_Header.dwSections + 1) * 2;

					System.out.print("Xbe::Xbe: Generating Section Headers...\n");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
					for (int v = 0;v < m_Header.dwSections;v++)
					{
						System.out.printf("Xbe::Xbe: Generating Section Header %.04X...", v);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long characteristics = x_Exe->m_SectionHeader[v].m_characteristics;
						int characteristics = x_Exe.m_SectionHeader[v].m_characteristics;

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
						memset(m_SectionHeader[v].dwFlags, 0, sizeof(m_SectionHeader.dwFlags));

						if ((characteristics & DefineConstants.IMAGE_SCN_MEM_WRITE) != 0)
						{
							m_SectionHeader[v].dwFlags.bWritable = true;
						}

						if ((characteristics & DefineConstants.IMAGE_SCN_MEM_EXECUTE) || (characteristics & DefineConstants.IMAGE_SCN_CNT_CODE))
						{
							m_SectionHeader[v].dwFlags.bExecutable = true;
						}

						m_SectionHeader[v].dwFlags.bPreload = true;
						m_SectionHeader[v].dwVirtualAddr = x_Exe.m_SectionHeader[v].m_virtual_addr + m_Header.dwPeBaseAddr;

						if (v < m_Header.dwSections - 1)
						{
							m_SectionHeader[v].dwVirtualSize = x_Exe.m_SectionHeader[v + 1].m_virtual_addr - x_Exe.m_SectionHeader[v].m_virtual_addr;
						}
						else
						{
							m_SectionHeader[v].dwVirtualSize = GlobalMembers.RoundUp(x_Exe.m_SectionHeader[v].m_virtual_size, 4);
						}

						m_SectionHeader[v].dwRawAddr = SectionCursor;

						{
						// calculate sizeof_raw by locating the last non-zero value in the raw section data
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long r = x_Exe->m_SectionHeader[v].m_sizeof_raw - 1;
							int r = x_Exe.m_SectionHeader[v].m_sizeof_raw - 1;

							while (r > 0)
							{
								if (x_Exe.m_bzSection[v][r--] != 0)
								{
									break;
								}
							}

							// word aligned
							m_SectionHeader[v].dwSizeofRaw = GlobalMembers.RoundUp(r + 2, 4);
						}

						SectionCursor += GlobalMembers.RoundUp(m_SectionHeader[v].dwSizeofRaw, 0x1000);

						{
						// head/tail reference count
							m_SectionHeader[v].dwHeadSharedRefCountAddr = hwc_htrc;
							htrc[v] = 0;

							hwc_htrc += 2;

							m_SectionHeader[v].dwTailSharedRefCountAddr = hwc_htrc;
							htrc[v + 1] = 0;
						}

						{
						// section name
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long s = 0;
							int s = 0;

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
							memset(secn, 0, 8);

							m_SectionHeader[v].dwSectionNameAddr = hwc_secn;
							while (s < 8 && x_Exe.m_SectionHeader[v].m_name[s] != '\0')
							{
								m_szSectionName.charAt(v)[s] = secn[s] = x_Exe.m_SectionHeader[v].m_name[s];
								s++;
							}

							m_szSectionName.charAt(v)[s] = '\0';

							secn += s + 1;
							hwc_secn += s + 1;
						}

						m_SectionHeader[v].dwSectionRefCount = 0;

						// write section digest (just zeros)
//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
						memset(m_SectionHeader[v].bzSectionDigest, 0, 20);

						// write section header
//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memcpy' has no equivalent in Java:
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
						memcpy(szBuffer, m_SectionHeader[v], sizeof(m_SectionHeader));

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
						szBuffer += sizeof(m_SectionHeader);

						System.out.print("OK\n");
					}

					hwc = hwc_secn;
				}

				{
				// write debug path / debug file names
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: *(unsigned short*)szBuffer = 0x0000;
					(short)szBuffer = 0x0000;

					szBuffer += 2;
					hwc += 2;
				}

				{
				// write default "OpenXDK" logo bitmap
					System.out.print("Xbe::Xbe: Generating \"OpenXDK\" Logo Bitmap...");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned char *RawAddr = GetAddr(m_Header.dwLogoBitmapAddr);
//C++ TO JAVA CONVERTER TODO TASK: Java does not have an equivalent to pointers to value types:
//ORIGINAL LINE: byte *RawAddr = GetAddr(m_Header.dwLogoBitmapAddr);
					byte RawAddr = GetAddr(m_Header.dwLogoBitmapAddr);

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
					memset(RawAddr, 0, 100 * 17);

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memcpy' has no equivalent in Java:
					memcpy(RawAddr, OpenXDK, dwSizeOfOpenXDK);

					m_Header.dwSizeofLogoBitmap = dwSizeOfOpenXDK;

					System.out.print("OK\n");
				}

				{
				// write sections
					System.out.print("Xbe::Xbe: Generating Sections...\n");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: m_bzSection = new unsigned char*[m_Header.dwSections];
					m_bzSection = new byte[m_Header.dwSections][];

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
					memset(m_bzSection, 0, m_Header.dwSections);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
					for (int v = 0;v < m_Header.dwSections;v++)
					{
						System.out.printf("Xbe::Xbe: Generating Section %.04X...", v);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long RawSize = m_SectionHeader[v].dwSizeofRaw;
						int RawSize = m_SectionHeader[v].dwSizeofRaw;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: m_bzSection[v] = new unsigned char[RawSize];
						m_bzSection[v] = new byte[RawSize];

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memcpy' has no equivalent in Java:
						memcpy(m_bzSection[v], x_Exe.m_bzSection[v], RawSize);

						System.out.print("OK\n");
					}
				}
			}

			System.out.print("Xbe::Xbe: Pass 4 (Finalizing)...\n");

			{
			// pass 4
				m_Header.dwSizeofImage = m_SectionHeader[m_Header.dwSections - 1].dwVirtualAddr + m_SectionHeader[m_Header.dwSections - 1].dwVirtualSize - m_Header.dwBaseAddr;

				m_Header.dwTLSAddr = 0;

				{
				// relocate to base : 0x00010000
					System.out.print("Xbe::Xbe: Relocating to Base 0x00010000...");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long fixCount = 0;
					int fixCount = 0;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long relo_addr = x_Exe->m_OptionalHeader.m_image_data_directory[5].m_virtual_addr;
					int relo_addr = x_Exe.m_OptionalHeader.m_image_data_directory[5].m_virtual_addr;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long relo_size = x_Exe->m_OptionalHeader.m_image_data_directory[5].m_size;
					int relo_size = x_Exe.m_OptionalHeader.m_image_data_directory[5].m_size;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long dwBaseDiff = m_Header.dwPeBaseAddr - x_Exe->m_OptionalHeader.m_image_base;
					int dwBaseDiff = m_Header.dwPeBaseAddr - x_Exe.m_OptionalHeader.m_image_base;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned char *reloc = GetAddr(relo_addr + m_Header.dwPeBaseAddr);
					byte[] reloc = GetAddr(relo_addr + m_Header.dwPeBaseAddr);

					// relocate, if necessary
					if (reloc != 0)
					{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long v = 0;
						int v = 0;

						// relocate each relocation block
						while (v < relo_size)
						{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long block_addr = *(unsigned long *)&reloc[v+0];
							int block_addr = (int) reloc[v + 0];
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long block_stop = *(unsigned long *)&reloc[v+4] + v;
							int block_stop = (int) reloc[v + 4] + v;

							v += 8;

							// relocate each rva
							while (v < block_stop && v < relo_size)
							{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned short data = *(unsigned short *)&reloc[v];
								short data = (short) reloc[v];

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long type = (data & 0xF000) >> 12;
//C++ TO JAVA CONVERTER WARNING: The right shift operator was not replaced by Java's logical right shift operator since the left operand was not confirmed to be of an unsigned type, but you should review whether the logical right shift operator (>>>) is more appropriate:
								int type = (data & 0xF000) >> 12;

								if (type == 0)
								{
									v += 2;
									break;
								}

								// 32-bit field relocation
								if (type == DefineConstants.IMAGE_REL_BASED_HIGHLOW)
								{
									fixCount++;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long dwFixAddr = block_addr + (data & 0x0FFF) + m_Header.dwPeBaseAddr;
									int dwFixAddr = block_addr + (data & 0x0FFF) + m_Header.dwPeBaseAddr;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned char *bzModRVA = GetAddr(dwFixAddr);
//C++ TO JAVA CONVERTER TODO TASK: Pointer arithmetic is detected on this variable, so pointers on this variable are left unchanged:
									byte * bzModRVA = GetAddr(dwFixAddr);

									if (bzModRVA != 0)
									{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: *(unsigned long*)bzModRVA += dwBaseDiff;
										(int)bzModRVA += dwBaseDiff;
									}
								}
								else
								{
									SetError("Unsupported relocation type", true);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
									goto cleanup;
								}

								v += 2;
							}
						}
					}

					System.out.printf("OK (%d Fixups)\n", fixCount);
				}

				{
				// locate kernel thunk table
					// unfortunately, GCC doesn't populate the IAT entry in the data directory
					// so if the value is 0, then it could mean there are no imports, or it
					// could mean the EXE was compiled by GCC
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long ktRVA = x_Exe->m_OptionalHeader.m_image_data_directory[12].m_virtual_addr;
					int ktRVA = x_Exe.m_OptionalHeader.m_image_data_directory[12].m_virtual_addr;

					if (ktRVA == 0)
					{
						// lets check to see if there is an import section. if so, look at offset 16
						// for the RVA of the Import Address Table
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long importRVA = x_Exe->m_OptionalHeader.m_image_data_directory[1].m_virtual_addr;
						int importRVA = x_Exe.m_OptionalHeader.m_image_data_directory[1].m_virtual_addr;

						if (importRVA != 0)
						{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned char *importSection = GetAddr(importRVA + m_Header.dwPeBaseAddr);
							byte[] importSection = GetAddr(importRVA + m_Header.dwPeBaseAddr);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: ktRVA = *(unsigned long *)&importSection[16];
							ktRVA = (int) importSection[16];
						}
					}

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long kt = ktRVA + m_Header.dwPeBaseAddr;
					int kt = ktRVA + m_Header.dwPeBaseAddr;

					kt ^= (x_bRetail ? GlobalMembers.XOR_KT_RETAIL : GlobalMembers.XOR_KT_DEBUG);

					m_Header.dwKernelImageThunkAddr = kt;
				}
			}

//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
		cleanup:

			if (GetError() != 0)
			{
				System.out.print("FAILED!\n");
				System.out.printf("Xbe::Xbe: ERROR -> %s\n", GetError());
			}

			return;
		}

		// deconstructor

	   // deconstructor
	   public void dispose()
	   {
		   if (m_bzSection != 0)
		   {
	   //C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	   //ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
			   for (int v = 0;v < m_Header.dwSections;v++)
			   {
				   m_bzSection[v] = null;
			   }

			   m_bzSection = null;
		   }

		   m_XAPILibraryVersion = null;
		   m_KernelLibraryVersion = null;
		   m_LibraryVersion = null;
		   m_TLS = null;
		   m_szSectionName = null;
		   m_SectionHeader = null;
		   m_HeaderEx = null;
		   super.dispose();
	   }

		// export to Xbe file

		// export to Xbe file
		public final void Export(String x_szXbeFilename)
		{
			if (GetError() != 0)
			{
				return;
			}

			String szBuffer = new String(new char[260]);

			System.out.print("Xbe::Export: Writing Xbe file...");

			FILE XbeFile = fopen(x_szXbeFilename, "wb");

			// verify Xbe file was opened successfully
			if (XbeFile == 0)
			{
				SetError("Could not open .xbe file.", false);
				return;
			}

			System.out.print("OK\n");

			{
			// write Xbe image header
				System.out.print("Xbe::Export: Writing Image Header...");

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				if (fwrite(m_Header, sizeof(m_Header), 1, XbeFile) != 1)
				{
					SetError("Unexpected write error while writing Xbe Image Header", false);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				System.out.print("OK\n");

				System.out.print("Xbe::Export: Writing Image Header Extra Bytes...");

				if (fwrite(m_HeaderEx, m_Header.dwSizeofHeaders, 1, XbeFile) != 1)
				{
					SetError("Unexpected write error while writing Xbe Image Header (Ex)", false);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				System.out.print("OK\n");
			}

			{
			// write Xbe certificate
				System.out.print("Xbe::Export: Writing Certificate...");

				fseek(XbeFile, m_Header.dwCertificateAddr - m_Header.dwBaseAddr, SEEK_SET);

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				if (fwrite(m_Certificate, sizeof(m_Certificate), 1, XbeFile) != 1)
				{
					SetError("Unexpected write error while writing Xbe Certificate", false);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				System.out.print("OK\n");
			}

			{
			// write Xbe section headers
				System.out.print("Xbe::Export: Writing Section Headers...\n");

				fseek(XbeFile, m_Header.dwSectionHeadersAddr - m_Header.dwBaseAddr, SEEK_SET);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
				for (int v = 0;v < m_Header.dwSections;v++)
				{
					System.out.printf("Xbe::Export: Writing Section Header 0x%.04X...", v);

//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
					if (fwrite(m_SectionHeader[v], sizeof(m_SectionHeader), 1, XbeFile) != 1)
					{
						szBuffer = String.format("Unexpected write error while writing Xbe Section %d (%Xh)", v, v);
						SetError(szBuffer, false);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					System.out.print("OK\n");
				}
			}

			{
			// write Xbe sections
				System.out.print("Xbe::Export: Writing Sections...\n");

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
				for (int v = 0;v < m_Header.dwSections;v++)
				{
					System.out.printf("Xbe::Export: Writing Section 0x%.04X (%s)...", v, m_szSectionName.charAt(v));

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long RawSize = m_SectionHeader[v].dwSizeofRaw;
					int RawSize = m_SectionHeader[v].dwSizeofRaw;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long RawAddr = m_SectionHeader[v].dwRawAddr;
					int RawAddr = m_SectionHeader[v].dwRawAddr;

					fseek(XbeFile, RawAddr, SEEK_SET);

					if (RawSize == 0)
					{
						System.out.print("OK\n");
						continue;
					}

					if (fwrite(m_bzSection[v], RawSize, 1, XbeFile) != 1)
					{
						szBuffer = String.format("Unexpected write error while writing Xbe Section %d (%Xh) (%s)", v, v, m_szSectionName.charAt(v));
						SetError(szBuffer, false);
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}

					System.out.print("OK\n");
				}
			}

			{
			// zero pad
				System.out.print("Xbe::Export: Writing Zero Padding...");

				fpos_t pos = new fpos_t();

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long remaining = 0;
				int remaining = 0;

				fgetpos(XbeFile, pos);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: remaining = (unsigned long)(0x1000 - ftell(XbeFile)%0x1000);
				remaining = (int)(0x1000 - ftell(XbeFile) % 0x1000);

				{
				// write remaining bytes
					String szBuffer = new String(new char[remaining - 1]);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<remaining;v++)
					for (int v = 0;v < remaining;v++)
					{
						szBuffer = szBuffer.substring(0, v);
					}

					fwrite(szBuffer, remaining, 1, XbeFile);

					szBuffer = null;
				}

				System.out.print("OK\n");
			}

//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
		cleanup:

			// if we came across an error, delete the file we were creating
			if (GetError() != 0)
			{
				remove(x_szXbeFilename);
				System.out.print("FAILED!\n");
				System.out.printf("Xbe::Export: ERROR -> %s\n", GetError());
			}

			fclose(XbeFile);
		}

		// dump Xbe information to text file

		// dump Xbe information to text file
		public final void DumpInformation(FILE x_file)
		{
			if (GetError() != 0)
			{
				return;
			}

			fprintf(x_file, "XBE information generated by CXBX (Version " DefineConstants._CXBX_VERSION ")\n");
			fprintf(x_file, "\n");
			fprintf(x_file, "Title identified as \"%s\"\n", m_szAsciiTitle);
			fprintf(x_file, "\n");
			fprintf(x_file, "Dumping XBE file header...\n");
			fprintf(x_file, "\n");
			fprintf(x_file, "Magic Number                     : XBEH\n");

			{
			// print digital signature
				fprintf(x_file, "Digitial Signature               : <Hex Dump>");
				for (int y = 0;y < 16;y++)
				{
					fprintf(x_file, "\n                                   ");
					for (int x = 0;x < 16;x++)
					{
						fprintf(x_file, "%.02X", m_Header.pbDigitalSignature[y * 16 + x]);
					}
				}
				fprintf(x_file, "\n                                   </Hex Dump>\n");
			}

			fprintf(x_file, "Base Address                     : 0x%.08X\n", m_Header.dwBaseAddr);
			fprintf(x_file, "Size of Headers                  : 0x%.08X\n", m_Header.dwSizeofHeaders);
			fprintf(x_file, "Size of Image                    : 0x%.08X\n", m_Header.dwSizeofImage);
			fprintf(x_file, "Size of Image Header             : 0x%.08X\n", m_Header.dwSizeofImageHeader);
			fprintf(x_file, "TimeDate Stamp                   : 0x%.08X (%s)\n", m_Header.dwTimeDate, GlobalMembers.BetterTime(ctime((time_t) & m_Header.dwTimeDate)));
			fprintf(x_file, "Certificate Address              : 0x%.08X\n", m_Header.dwCertificateAddr);
			fprintf(x_file, "Number of Sections               : 0x%.08X\n", m_Header.dwSections);
			fprintf(x_file, "Section Headers Address          : 0x%.08X\n", m_Header.dwSectionHeadersAddr);

			{
			// print init flags
				fprintf(x_file, "Init Flags                       : 0x%.08X ", m_Header.dwInitFlags);

				if (m_Header.dwInitFlags.bMountUtilityDrive)
				{
					fprintf(x_file, "[Mount Utility Drive] ");
				}

				if (m_Header.dwInitFlags.bFormatUtilityDrive)
				{
					fprintf(x_file, "[Format Utility Drive] ");
				}

				if (m_Header.dwInitFlags.bLimit64MB)
				{
					fprintf(x_file, "[Limit Devkit Run Time Memory to 64MB] ");
				}

				if (!m_Header.dwInitFlags.bDontSetupHarddisk)
				{
					fprintf(x_file, "[Setup Harddisk] ");
				}

				fprintf(x_file, "\n");
			}

			String AsciiFilename = new String(new char[40]);

			setlocale(LC_ALL, "English");

//C++ TO JAVA CONVERTER TODO TASK: Java does not have an equivalent to pointers to value types:
//ORIGINAL LINE: const char *wszFilename = (const char *)GetAddr(m_Header.dwDebugUnicodeFilenameAddr);
			char wszFilename = (char)GetAddr(m_Header.dwDebugUnicodeFilenameAddr);

			if (wszFilename != null)
			{
				wcstombs(AsciiFilename, wszFilename, 40);
			}
			else
			{
				AsciiFilename = tangible.StringFunctions.changeCharacter(AsciiFilename, 0, '\0');
			}

			fprintf(x_file, "Entry Point                      : 0x%.08X (Retail: 0x%.08X, Debug: 0x%.08X)\n", m_Header.dwEntryAddr, m_Header.dwEntryAddr ^ GlobalMembers.XOR_EP_RETAIL, m_Header.dwEntryAddr ^ GlobalMembers.XOR_EP_DEBUG);
			fprintf(x_file, "TLS Address                      : 0x%.08X\n", m_Header.dwTLSAddr);
			fprintf(x_file, "(PE) Stack Commit                : 0x%.08X\n", m_Header.dwPeStackCommit);
			fprintf(x_file, "(PE) Heap Reserve                : 0x%.08X\n", m_Header.dwPeHeapReserve);
			fprintf(x_file, "(PE) Heap Commit                 : 0x%.08X\n", m_Header.dwPeHeapCommit);
			fprintf(x_file, "(PE) Base Address                : 0x%.08X\n", m_Header.dwPeBaseAddr);
			fprintf(x_file, "(PE) Size of Image               : 0x%.08X\n", m_Header.dwPeSizeofImage);
			fprintf(x_file, "(PE) Checksum                    : 0x%.08X\n", m_Header.dwPeChecksum);
			fprintf(x_file, "(PE) TimeDate Stamp              : 0x%.08X (%s)\n", m_Header.dwPeTimeDate, GlobalMembers.BetterTime(ctime((time_t) & m_Header.dwPeTimeDate)));
			fprintf(x_file, "Debug Pathname Address           : 0x%.08X (\"%s\")\n", m_Header.dwDebugPathnameAddr, GetAddr(m_Header.dwDebugPathnameAddr));
			fprintf(x_file, "Debug Filename Address           : 0x%.08X (\"%s\")\n", m_Header.dwDebugFilenameAddr, GetAddr(m_Header.dwDebugFilenameAddr));
			fprintf(x_file, "Debug Unicode filename Address   : 0x%.08X (L\"%s\")\n", m_Header.dwDebugUnicodeFilenameAddr, AsciiFilename);
			fprintf(x_file, "Kernel Image Thunk Address       : 0x%.08X (Retail: 0x%.08X, Debug: 0x%.08X)\n", m_Header.dwKernelImageThunkAddr, m_Header.dwKernelImageThunkAddr ^ GlobalMembers.XOR_KT_RETAIL, m_Header.dwKernelImageThunkAddr ^ GlobalMembers.XOR_KT_DEBUG);
			fprintf(x_file, "NonKernel Import Dir Address     : 0x%.08X\n", m_Header.dwNonKernelImportDirAddr);
			fprintf(x_file, "Library Versions                 : 0x%.08X\n", m_Header.dwLibraryVersions);
			fprintf(x_file, "Library Versions Address         : 0x%.08X\n", m_Header.dwLibraryVersionsAddr);
			fprintf(x_file, "Kernel Library Version Address   : 0x%.08X\n", m_Header.dwKernelLibraryVersionAddr);
			fprintf(x_file, "XAPI Library Version Address     : 0x%.08X\n", m_Header.dwXAPILibraryVersionAddr);
			fprintf(x_file, "Logo Bitmap Address              : 0x%.08X\n", m_Header.dwLogoBitmapAddr);
			fprintf(x_file, "Logo Bitmap Size                 : 0x%.08X\n", m_Header.dwSizeofLogoBitmap);
			fprintf(x_file, "\n");
			fprintf(x_file, "Dumping XBE Certificate...\n");
			fprintf(x_file, "\n");
			fprintf(x_file, "Size of Certificate              : 0x%.08X\n", m_Certificate.dwSize);
			fprintf(x_file, "TimeDate Stamp                   : 0x%.08X (%s)\n", m_Certificate.dwTimeDate, GlobalMembers.BetterTime(ctime((time_t) m_Certificate.dwTimeDate)));
			fprintf(x_file, "Title ID                         : 0x%.08X\n", m_Certificate.dwTitleId);
			fprintf(x_file, "Title                            : L\"%s\"\n", m_szAsciiTitle);

			{
			// print alternate title IDs
				fprintf(x_file, "Alternate Titles IDs             : ");

				for (int v = 0;v < 0x10;v++)
				{
					if (v != 0)
					{
						fprintf(x_file, "                                   ");
					}
					fprintf(x_file, "0x%.08X", m_Certificate.dwAlternateTitleId[v]);
					if (v != 0x0F)
					{
						fprintf(x_file, "\n");
					}
				}

				fprintf(x_file, "\n");
			}

			fprintf(x_file, "Allowed Media                    : 0x%.08X\n", m_Certificate.dwAllowedMedia);
			fprintf(x_file, "Game Region                      : 0x%.08X\n", m_Certificate.dwGameRegion);
			fprintf(x_file, "Game Ratings                     : 0x%.08X\n", m_Certificate.dwGameRatings);
			fprintf(x_file, "Disk Number                      : 0x%.08X\n", m_Certificate.dwDiskNumber);
			fprintf(x_file, "Version                          : 0x%.08X\n", m_Certificate.dwVersion);

			{
			// print LAN key
				fprintf(x_file, "LAN Key                          : ");
				for (int x = 0;x < 16;x++)
				{
					fprintf(x_file, "%.02X", m_Certificate.bzLanKey[x]);
				}
				fprintf(x_file, "\n");
			}

			{
			// print signature key
				fprintf(x_file, "Signature Key                    : ");
				for (int x = 0;x < 16;x++)
				{
					fprintf(x_file, "%.02X", m_Certificate.bzSignatureKey[x]);
				}
				fprintf(x_file, "\n");
			}

			{
			// print alternate signature keys
				fprintf(x_file, "Title Alternate Signature Keys : <Hex Dump>");
				for (int y = 0;y < 16;y++)
				{
					fprintf(x_file, "\n                                   ");
					for (int x = 0;x < 16;x++)
					{
						fprintf(x_file, "%.02X", m_Certificate.bzTitleAlternateSignatureKey[y][x]);
					}
				}
				fprintf(x_file, "\n                                   </Hex Dump>\n");
			}

			fprintf(x_file, "\n");
			fprintf(x_file, "Dumping XBE Section Headers...\n");
			fprintf(x_file, "\n");

			{
			// print section headers
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
				for (int v = 0;v < m_Header.dwSections;v++)
				{
					fprintf(x_file, "Section Name                     : 0x%.08X (\"%s\")\n", m_SectionHeader[v].dwSectionNameAddr, m_szSectionName.charAt(v));

					{
					// print flags
						fprintf(x_file, "Flags                            : 0x%.08X ", m_SectionHeader[v].dwFlags);

						if (m_SectionHeader[v].dwFlags.bWritable)
						{
							fprintf(x_file, "(Writable) ");
						}

						if (m_SectionHeader[v].dwFlags.bPreload)
						{
							fprintf(x_file, "(Preload) ");
						}

						if (m_SectionHeader[v].dwFlags.bExecutable)
						{
							fprintf(x_file, "(Executable) ");
						}

						if (m_SectionHeader[v].dwFlags.bInsertedFile)
						{
							fprintf(x_file, "(Inserted File) ");
						}

						if (m_SectionHeader[v].dwFlags.bHeadPageRO)
						{
							fprintf(x_file, "(Head Page RO) ");
						}

						if (m_SectionHeader[v].dwFlags.bTailPageRO)
						{
							fprintf(x_file, "(Tail Page RO) ");
						}

						fprintf(x_file, "\n");
					}

					fprintf(x_file, "Virtual Address                  : 0x%.08X\n", m_SectionHeader[v].dwVirtualAddr);
					fprintf(x_file, "Virtual Size                     : 0x%.08X\n", m_SectionHeader[v].dwVirtualSize);
					fprintf(x_file, "Raw Address                      : 0x%.08X\n", m_SectionHeader[v].dwRawAddr);
					fprintf(x_file, "Size of Raw                      : 0x%.08X\n", m_SectionHeader[v].dwSizeofRaw);
					fprintf(x_file, "Section Name Address             : 0x%.08X\n", m_SectionHeader[v].dwSectionNameAddr);
					fprintf(x_file, "Section Reference Count          : 0x%.08X\n", m_SectionHeader[v].dwSectionRefCount);
					fprintf(x_file, "Head Shared Reference Count Addr : 0x%.08X\n", m_SectionHeader[v].dwHeadSharedRefCountAddr);
					fprintf(x_file, "Tail Shared Reference Count Addr : 0x%.08X\n", m_SectionHeader[v].dwTailSharedRefCountAddr);

					{
					// print section digest
						fprintf(x_file, "Section Digest                   : ");
						for (int s = 0;s < 20;s++)
						{
							fprintf(x_file, "%.02X", m_SectionHeader[v].bzSectionDigest[s]);
						}
						fprintf(x_file, "\n");
					}

					fprintf(x_file, "\n");
				}
			}

			fprintf(x_file, "Dumping XBE Library Versions...\n");
			fprintf(x_file, "\n");

			{
			// print library versions
				if (m_LibraryVersion == 0 || m_Header.dwLibraryVersions == 0)
				{
					fprintf(x_file, "(This XBE contains no Library Versions)\n");
					fprintf(x_file, "\n");
				}
				else
				{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwLibraryVersions;v++)
					for (int v = 0;v < m_Header.dwLibraryVersions;v++)
					{
						String tmp = new String(new char[9]);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long c=0;c<8;c++)
						for (int c = 0;c < 8;c++)
						{
							tmp = tangible.StringFunctions.changeCharacter(tmp, c, m_LibraryVersion[v].szName[c]);
						}

						tmp = tangible.StringFunctions.changeCharacter(tmp, 8, '\0');

						fprintf(x_file, "Library Name                     : %s\n", tmp);
						fprintf(x_file, "Version                          : %d.%d.%d\n", m_LibraryVersion[v].wMajorVersion, m_LibraryVersion[v].wMinorVersion, m_LibraryVersion[v].wBuildVersion);

						{
						// print flags
							fprintf(x_file, "Flags                            : ");

							fprintf(x_file, "QFEVersion : 0x%.04X, ", m_LibraryVersion[v].dwFlags.QFEVersion);

							if (m_LibraryVersion[v].dwFlags.bDebugBuild)
							{
								fprintf(x_file, "Debug, ");
							}
							else
							{
								fprintf(x_file, "Retail, ");
							}

							switch (m_LibraryVersion[v].dwFlags.Approved)
							{
								case 0:
									fprintf(x_file, "Unapproved");
									break;
								case 1:
									fprintf(x_file, "Possibly Approved");
									break;
								case 2:
									fprintf(x_file, "Approved");
									break;
							}

							fprintf(x_file, "\n");
						}

						fprintf(x_file, "\n");
					}
				}
			}

			fprintf(x_file, "Dumping XBE TLS...\n");
			fprintf(x_file, "\n");

			// print thread local storage
			if (m_TLS != 0)
			{
				fprintf(x_file, "Data Start Address               : 0x%.08X\n", m_TLS.dwDataStartAddr);
				fprintf(x_file, "Data End Address                 : 0x%.08X\n", m_TLS.dwDataEndAddr);
				fprintf(x_file, "TLS Index Address                : 0x%.08X\n", m_TLS.dwTLSIndexAddr);
				fprintf(x_file, "TLS Callback Address             : 0x%.08X\n", m_TLS.dwTLSCallbackAddr);
				fprintf(x_file, "Size of Zero Fill                : 0x%.08X\n", m_TLS.dwSizeofZeroFill);
				fprintf(x_file, "Characteristics                  : 0x%.08X\n", m_TLS.dwCharacteristics);
			}
			else
			{
				fprintf(x_file, "(This XBE contains no TLS)\n");
			}
		}

		// import logo bitmap from raw monochrome data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: void ImportLogoBitmap(const unsigned char x_Gray[100*17]);

		// import logo bitmap from raw monochrome data
		public final void ImportLogoBitmap(byte[] x_Gray)
		{
			String LogoBuffer = new String(new char[4 * 1024 - 1]);
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long LogoSize = 0;
			int LogoSize = 0;

			{
			// encode logo bitmap
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=1;v<100*17;LogoSize++)
				for (int v = 1;v < 100 * 17;LogoSize++)
				{
//C++ TO JAVA CONVERTER WARNING: The right shift operator was replaced by Java's logical right shift operator since the left operand was originally of an unsigned type, but you should confirm this replacement:
					byte color = x_Gray[v] >>> 4;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long len = 1;
					int len = 1;

//C++ TO JAVA CONVERTER WARNING: The right shift operator was replaced by Java's logical right shift operator since the left operand was originally of an unsigned type, but you should confirm this replacement:
					while (++v < 100 * 17 - 1 && len < 1024 && color == x_Gray[v] >>> 4)
					{
						len++;
					}

					LogoRLE cur = (LogoRLE) LogoBuffer.charAt(LogoSize);

					if (len <= 7)
					{
						cur.m_Eight.bType1 = 1;
						cur.m_Eight.Len = len;
						cur.m_Eight.Data = color;
					}
					else
					{
						cur.m_Sixteen.bType1 = 0;
						cur.m_Sixteen.bType2 = 1;
						cur.m_Sixteen.Len = len;
						cur.m_Sixteen.Data = color;
						LogoSize++;
					}
				}
			}

			{
			// check if there is room to save this, if not then throw an error
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned char *RLE = GetLogoBitmap(LogoSize);
//C++ TO JAVA CONVERTER TODO TASK: Java does not have an equivalent to pointers to value types:
//ORIGINAL LINE: byte *RLE = GetLogoBitmap(LogoSize);
				byte RLE = GetLogoBitmap(LogoSize);

				if (RLE == 0)
				{
					if (GetError() == 0)
					{
						SetError("Logo bitmap could not be imported (not enough space in file?)", false);
					}

					return;
				}

//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memcpy' has no equivalent in Java:
				memcpy(RLE, LogoBuffer, LogoSize);
			}

			return;
		}

		// export logo bitmap to raw monochrome data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: void ExportLogoBitmap(unsigned char x_Gray[100*17]);

		// ******************************************************************
		// * ExportLogoBitmap
		// ******************************************************************
		// *
		// * This algorithm was originally discovered by superfro. I couldnt
		// * figure out what the hell the encoding format was before he gave
		// * me the information:
		// *
		// * basically what is going on here is a single pass through the
		// * bitmap data, with 2 possible encodings per rle chunk. data is
		// * stored as 4 bit grayscale, so the logical approach is to expand
		// * this to 8 bit using a simple 4 bit left shift (*16). However, it
		// * has been suggested to me by superfro that you might calculate a
		// * slightly darker image by multiplying by 15 and adding .5. It's
		// * a toss up, but i've choosen a simple bit shift left.
		// *
		// ******************************************************************
		public final void ExportLogoBitmap(byte[] x_Gray)
		{
//C++ TO JAVA CONVERTER TODO TASK: The memory management function 'memset' has no equivalent in Java:
			memset(x_Gray, 0, 100 * 17);

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long dwLength = m_Header.dwSizeofLogoBitmap;
			int dwLength = m_Header.dwSizeofLogoBitmap;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned char *RLE = GetAddr(m_Header.dwLogoBitmapAddr);
			byte[] RLE = GetAddr(m_Header.dwLogoBitmapAddr);

			if (RLE == 0 || GetError() != 0)
			{
				return;
			}

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long o = 0;
			int o = 0;

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<dwLength;v++)
			for (int v = 0;v < dwLength;v++)
			{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long len = 0, data = 0;
				int len = 0;
				int data = 0;

				LogoRLE cur = (LogoRLE) RLE[v];

				if (cur.m_Eight.bType1)
				{
					len = cur.m_Eight.Len;
					data = cur.m_Eight.Data;
				}
				else
				{
					if (cur.m_Sixteen.bType2)
					{
						len = cur.m_Sixteen.Len;
						data = cur.m_Sixteen.Data;
						v += 1;
					}
				}

		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long j=0;j<len;j++)
				for (int j = 0;j < len;j++)
				{
					o++;

					if (o < 100 * 17)
					{
						x_Gray[o] = (byte)(data << 4); // could use (int)(data * 15.0 + .5);
					}
				}
			}
		}

		// Xbe header
		public static class Header
		{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwMagic;
			public int dwMagic; // 0x0000 - magic number [should be "XBEH"]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char pbDigitalSignature[256];
			public byte[] pbDigitalSignature = new byte[256]; // 0x0004 - digital signature
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwBaseAddr;
			public int dwBaseAddr; // 0x0104 - base address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSizeofHeaders;
			public int dwSizeofHeaders; // 0x0108 - size of headers
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSizeofImage;
			public int dwSizeofImage; // 0x010C - size of image
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSizeofImageHeader;
			public int dwSizeofImageHeader; // 0x0110 - size of image header
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwTimeDate;
			public int dwTimeDate; // 0x0114 - timedate stamp
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwCertificateAddr;
			public int dwCertificateAddr; // 0x0118 - certificate address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSections;
			public int dwSections; // 0x011C - number of sections
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSectionHeadersAddr;
			public int dwSectionHeadersAddr; // 0x0120 - section headers address

			public static class InitFlags // 0x0124 - initialization flags
			{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bMountUtilityDrive : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bMountUtilityDrive : 1; // mount utility drive flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bFormatUtilityDrive : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bFormatUtilityDrive : 1; // format utility drive flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bLimit64MB : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bLimit64MB : 1; // limit development kit run time memory to 64mb flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bDontSetupHarddisk : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bDontSetupHarddisk : 1; // don't setup hard disk flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused : 4;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused : 4; // unused (or unknown)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_b1 : 8;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_b1 : 8; // unused (or unknown)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_b2 : 8;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_b2 : 8; // unused (or unknown)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_b3 : 8;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_b3 : 8; // unused (or unknown)
			}
			public InitFlags dwInitFlags = new InitFlags();

//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwEntryAddr;
			public int dwEntryAddr; // 0x0128 - entry point address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwTLSAddr;
			public int dwTLSAddr; // 0x012C - thread local storage directory address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwPeStackCommit;
			public int dwPeStackCommit; // 0x0130 - size of stack commit
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwPeHeapReserve;
			public int dwPeHeapReserve; // 0x0134 - size of heap reserve
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwPeHeapCommit;
			public int dwPeHeapCommit; // 0x0138 - size of heap commit
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwPeBaseAddr;
			public int dwPeBaseAddr; // 0x013C - original base address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwPeSizeofImage;
			public int dwPeSizeofImage; // 0x0140 - size of original image
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwPeChecksum;
			public int dwPeChecksum; // 0x0144 - original checksum
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwPeTimeDate;
			public int dwPeTimeDate; // 0x0148 - original timedate stamp
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwDebugPathnameAddr;
			public int dwDebugPathnameAddr; // 0x014C - debug pathname address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwDebugFilenameAddr;
			public int dwDebugFilenameAddr; // 0x0150 - debug filename address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwDebugUnicodeFilenameAddr;
			public int dwDebugUnicodeFilenameAddr; // 0x0154 - debug unicode filename address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwKernelImageThunkAddr;
			public int dwKernelImageThunkAddr; // 0x0158 - kernel image thunk address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwNonKernelImportDirAddr;
			public int dwNonKernelImportDirAddr; // 0x015C - non kernel import directory address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwLibraryVersions;
			public int dwLibraryVersions; // 0x0160 - number of library versions
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwLibraryVersionsAddr;
			public int dwLibraryVersionsAddr; // 0x0164 - library versions address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwKernelLibraryVersionAddr;
			public int dwKernelLibraryVersionAddr; // 0x0168 - kernel library version address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwXAPILibraryVersionAddr;
			public int dwXAPILibraryVersionAddr; // 0x016C - xapi library version address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwLogoBitmapAddr;
			public int dwLogoBitmapAddr; // 0x0170 - logo bitmap address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSizeofLogoBitmap;
			public int dwSizeofLogoBitmap; // 0x0174 - logo bitmap size
		}

		// Xbe header extra byte (used to preserve unknown data)
		public Header byte * m_HeaderEx = new Header();

		// Xbe certificate
		public static class Certificate
		{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSize;
			public int dwSize; // 0x0000 - size of certificate
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwTimeDate;
			public int dwTimeDate; // 0x0004 - timedate stamp
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwTitleId;
			public int dwTitleId; // 0x0008 - title id
			public char[] wszTitleName = new char[40]; // 0x000C - title name (unicode)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwAlternateTitleId[0x10];
			public int[] dwAlternateTitleId = new int[0x10]; // 0x005C - alternate title ids
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwAllowedMedia;
			public int dwAllowedMedia; // 0x009C - allowed media types
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwGameRegion;
			public int dwGameRegion; // 0x00A0 - game region
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwGameRatings;
			public int dwGameRatings; // 0x00A4 - game ratings
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwDiskNumber;
			public int dwDiskNumber; // 0x00A8 - disk number
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwVersion;
			public int dwVersion; // 0x00AC - version
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char bzLanKey[16];
			public byte[] bzLanKey = new byte[16]; // 0x00B0 - lan key
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char bzSignatureKey[16];
			public byte[] bzSignatureKey = new byte[16]; // 0x00C0 - signature key
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char bzTitleAlternateSignatureKey[16][16];
			public byte[][] bzTitleAlternateSignatureKey = new byte[16][16]; // 0x00D0 - alternate signature keys
		}
		public Certificate m_Certificate = new Certificate();

		// Xbe section header
		public static class SectionHeader
		{
			public static class _Flags
			{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bWritable : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bWritable : 1; // writable flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bPreload : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bPreload : 1; // preload flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bExecutable : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bExecutable : 1; // executable flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bInsertedFile : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bInsertedFile : 1; // inserted file flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bHeadPageRO : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bHeadPageRO : 1; // head page read only flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bTailPageRO : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bTailPageRO : 1; // tail page read only flag
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_a1 : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_a1 : 1; // unused (or unknown)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_a2 : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_a2 : 1; // unused (or unknown)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_b1 : 8;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_b1 : 8; // unused (or unknown)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_b2 : 8;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_b2 : 8; // unused (or unknown)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Unused_b3 : 8;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Unused_b3 : 8; // unused (or unknown)
			}
			public _Flags dwFlags = new _Flags();

//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwVirtualAddr;
			public int dwVirtualAddr; // virtual address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwVirtualSize;
			public int dwVirtualSize; // virtual size
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwRawAddr;
			public int dwRawAddr; // file offset to raw data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSizeofRaw;
			public int dwSizeofRaw; // size of raw data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSectionNameAddr;
			public int dwSectionNameAddr; // section name addr
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSectionRefCount;
			public int dwSectionRefCount; // section reference count
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwHeadSharedRefCountAddr;
			public int dwHeadSharedRefCountAddr; // head shared page reference count address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwTailSharedRefCountAddr;
			public int dwTailSharedRefCountAddr; // tail shared page reference count address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char bzSectionDigest[20];
			public byte[] bzSectionDigest = new byte[20]; // section digest
		}
		public SectionHeader[] m_SectionHeader;

		// Xbe library versions
		public static class LibraryVersion
		{
			public String szName = new String(new char[8]); // library name
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short wMajorVersion;
			public short wMajorVersion; // major version
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short wMinorVersion;
			public short wMinorVersion; // minor version
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short wBuildVersion;
			public short wBuildVersion; // build version

			public static class Flags
			{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short QFEVersion : 13;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public short QFEVersion : 13; // QFE Version
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short Approved : 2;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public short Approved : 2; // Approved? (0:no, 1:possibly, 2:yes)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short bDebugBuild : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public short bDebugBuild : 1; // Is this a debug build?
			}
			public Flags dwFlags = new Flags();
		}
		public LibraryVersion m_LibraryVersion;
		public LibraryVersion m_KernelLibraryVersion;
		public LibraryVersion m_XAPILibraryVersion;

		// Xbe thread local storage
		public static class TLS
		{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwDataStartAddr;
			public int dwDataStartAddr; // raw start address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwDataEndAddr;
			public int dwDataEndAddr; // raw end address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwTLSIndexAddr;
			public int dwTLSIndexAddr; // tls index  address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwTLSCallbackAddr;
			public int dwTLSCallbackAddr; // tls callback address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwSizeofZeroFill;
			public int dwSizeofZeroFill; // size of zero fill
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long dwCharacteristics;
			public int dwCharacteristics; // characteristics
		}
		public TLS m_TLS;

		// Xbe section names, each 8 bytes max and null terminated
		public String m_szSectionName = new String(new char[9]);

		// Xbe sections
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char **m_bzSection;
		public byte[][] m_bzSection;

		// Xbe original path
		public String m_szPath = new String(new char[260]);

		// Xbe ascii title, translated from certificate title
		public String m_szAsciiTitle = new String(new char[40]);

		// retrieve thread local storage data address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char *GetTLSData()
//C++ TO JAVA CONVERTER WARNING: Java has no equivalent to methods returning pointers to value types:
//ORIGINAL LINE: byte *GetTLSData()
		public final byte GetTLSData()
		{
			if (m_TLS == 0)
			{
				return 0;
			}
			else
			{
				return GetAddr(m_TLS.dwDataStartAddr);
			}
		}

		// retrieve thread local storage index address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long *GetTLSIndex()
//C++ TO JAVA CONVERTER WARNING: Java has no equivalent to methods returning pointers to value types:
//ORIGINAL LINE: uint *GetTLSIndex()
		public final int GetTLSIndex()
		{
			if (m_TLS == 0)
			{
				return 0;
			}
			else
			{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: return (unsigned long*)GetAddr(m_TLS->dwTLSIndexAddr);
				return (int)GetAddr(m_TLS.dwTLSIndexAddr);
			}
		}

		// constructor initialization

		// constructor initialization
		private void ConstructorInit()
		{
			m_HeaderEx = 0;
			m_SectionHeader = 0;
			m_szSectionName = 0;
			m_LibraryVersion = 0;
			m_KernelLibraryVersion = 0;
			m_XAPILibraryVersion = 0;
			m_TLS = 0;
			m_bzSection = 0;
		}

		// return a modifiable pointer inside this structure that corresponds to a virtual address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char *GetAddr(unsigned long x_dwVirtualAddress);

		// return a modifiable pointer inside this structure that corresponds to a virtual address
//C++ TO JAVA CONVERTER WARNING: Java has no equivalent to methods returning pointers to value types:
//ORIGINAL LINE: byte *GetAddr(uint x_dwVirtualAddress)
		private byte GetAddr(int x_dwVirtualAddress)
		{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long dwOffs = x_dwVirtualAddress - m_Header.dwBaseAddr;
			int dwOffs = x_dwVirtualAddress - m_Header.dwBaseAddr;

			// offset into image header
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
			if (dwOffs < sizeof(m_Header))
			{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: return &((unsigned char*)&m_Header)[dwOffs];
				return ((byte) & m_Header)[dwOffs];
			}

			// offset into image header extra bytes
			if (dwOffs < m_Header.dwSizeofHeaders)
			{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: return (unsigned char*)&m_HeaderEx[dwOffs - sizeof(m_Header)];
//C++ TO JAVA CONVERTER TODO TASK: There is no Java equivalent to 'sizeof':
				return (byte) m_HeaderEx.charAt(dwOffs - sizeof(m_Header));
			}

			{
			// offset into some random section
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: for(unsigned long v=0;v<m_Header.dwSections;v++)
				for (int v = 0;v < m_Header.dwSections;v++)
				{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long VirtAddr = m_SectionHeader[v].dwVirtualAddr;
					int VirtAddr = m_SectionHeader[v].dwVirtualAddr;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long VirtSize = m_SectionHeader[v].dwVirtualSize;
					int VirtSize = m_SectionHeader[v].dwVirtualSize;

					if ((x_dwVirtualAddress >= VirtAddr) && (x_dwVirtualAddress < (VirtAddr + VirtSize)))
					{
						return m_bzSection[v][x_dwVirtualAddress - VirtAddr];
					}
				}
			}

			return 0;
		}

		// return a modifiable pointer to logo bitmap data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char *GetLogoBitmap(unsigned long x_dwSize);

		// return a modifiable pointer to logo bitmap data
//C++ TO JAVA CONVERTER WARNING: Java has no equivalent to methods returning pointers to value types:
//ORIGINAL LINE: byte *GetLogoBitmap(uint x_dwSize)
		private byte GetLogoBitmap(int x_dwSize)
		{
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long dwOffs = m_Header.dwLogoBitmapAddr - m_Header.dwBaseAddr;
			int dwOffs = m_Header.dwLogoBitmapAddr - m_Header.dwBaseAddr;
		//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
		//ORIGINAL LINE: unsigned long dwLength = m_Header.dwSizeofLogoBitmap;
			int dwLength = m_Header.dwSizeofLogoBitmap;

			if (dwOffs == 0 || dwLength == 0)
			{
				return 0;
			}

			// if this bitmap will fit inside the already existing one, we don't need to resize, just return pointer
			if (dwLength >= x_dwSize)
			{
				// update size of headers, if necessary
				if (dwOffs < m_Header.dwSizeofHeaders)
				{
					m_Header.dwSizeofHeaders -= dwLength;
					m_Header.dwSizeofHeaders += x_dwSize;
					m_Header.dwSizeofLogoBitmap = x_dwSize;

					return GetAddr(m_Header.dwLogoBitmapAddr);
				}
			}

			return 0;
		}

		// used to encode/decode logo bitmap data
//C++ TO JAVA CONVERTER TODO TASK: Unions are not supported in Java:
//ORIGINAL LINE: union LogoRLE
		private final static class LogoRLE
		{
			public static class Eight
			{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bType1 : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bType1 : 1;
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Len : 3;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Len : 3;
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Data : 4;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Data : 4;
			}
			public Eight m_Eight = new Eight();

			public static class Sixteen
			{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bType1 : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bType1 : 1;
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long bType2 : 1;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int bType2 : 1;
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Len : 10;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Len : 10;
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long Data : 4;
//C++ TO JAVA CONVERTER TODO TASK: Java does not allow bit fields:
				public int Data : 4;
			}
			public Sixteen m_Sixteen = new Sixteen();
		}
}


// ******************************************************************
// *
// *    .,-:::::    .,::      .::::::::.    .,::      .:
// *  ,;;;'````'    `;;;,  .,;;  ;;;'';;'   `;;;,  .,;; 
// *  [[[             '[[,,[['   [[[__[[\.    '[[,,[['  
// *  $$$              Y$$$P     $$""""Y$$     Y$$$P    
// *  `88bo,__,o,    oP"``"Yo,  _88o,,od8P   oP"``"Yo,  
// *    "YUMMMMMP",m"       "Mm,""YUMMMP" ,m"       "Mm,
// *
// *   Cxbx->Core->Exe.h
// *
// *  This file is part of the Cxbx project.
// *
// *  Cxbx and Cxbe are free software; you can redistribute them
// *  and/or modify them under the terms of the GNU General Public
// *  License as published by the Free Software Foundation; either
// *  version 2 of the license, or (at your option) any later version.
// *
// *  This program is distributed in the hope that it will be useful,
// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// *  GNU General Public License for more details.
// *
// *  You should have recieved a copy of the GNU General Public License
// *  along with this program; see the file COPYING.
// *  If not, write to the Free Software Foundation, Inc.,
// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
// *
// *  (c) 2002-2003 Aaron Robinson <caustik@caustik.com>
// *
// *  All rights reserved
// *
// ******************************************************************


// Exe (PE) file object
public class Exe extends Error
{
		// construct via Exe file
//C++ TO JAVA CONVERTER TODO TASK: The implementation of the following method could not be found:
//		Exe(String x_szFilename);

		// deconstructor
//C++ TO JAVA CONVERTER TODO TASK: The implementation of the following method could not be found:
//	   public void dispose();

		// export to Exe file
//C++ TO JAVA CONVERTER TODO TASK: The implementation of the following method could not be found:
//		void Export(String x_szExeFilename);

		// DOSHeader
		public static class DOSHeader
		{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_magic;
			public short m_magic; // DOS .EXE magic number
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_cblp;
			public short m_cblp; // byte on last page
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_cp;
			public short m_cp; // number of pages
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_crlc;
			public short m_crlc; // number of relocations
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_cparhdr;
			public short m_cparhdr; // size of header (in paragraphs)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_minalloc;
			public short m_minalloc; // minimum extra paragraphs needed
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_maxalloc;
			public short m_maxalloc; // maximum extra paragraphs needed
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_ss;
			public short m_ss; // initial SS value (relative)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_sp;
			public short m_sp; // initial SP value
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_csum;
			public short m_csum; // checksum
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_ip;
			public short m_ip; // initial IP value
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_cs;
			public short m_cs; // initial CS value (relative)
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_lfarlc;
			public short m_lfarlc; // file address of relocation table
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_ovno;
			public short m_ovno; // overlay number
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_res[4];
			public short[] m_res = new short[4]; // reserved words
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_oemid;
			public short m_oemid; // OEM identifier
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_oeminfo;
			public short m_oeminfo; // OEM information
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_res2[10];
			public short[] m_res2 = new short[10]; // reserved words
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_lfanew;
			public int m_lfanew; // file address of new .EXE header
		}
		public DOSHeader m_DOSHeader = new DOSHeader();

		// Header (PE)
		public static class Header
		{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_magic;
			public int m_magic; // magic number [should be "PE\0\0"]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_machine;
			public short m_machine; // machine type
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_sections;
			public short m_sections; // number of sections
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_timedate;
			public int m_timedate; // timedate stamp
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_symbol_table_addr;
			public int m_symbol_table_addr; // symbol table address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_symbols;
			public int m_symbols; // number of symbols
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_sizeof_optional_header;
			public short m_sizeof_optional_header; // size of optional header
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_characteristics;
			public short m_characteristics; // characteristics
		}
		public Header m_Header = new Header();

		// optional header (PE)
		public static class OptionalHeader
		{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_magic;
			public short m_magic; // magic number [should be 0x010B]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char m_linker_version_major;
			public byte m_linker_version_major; // linker version [major]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char m_linker_version_minor;
			public byte m_linker_version_minor; // linker version [minor]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_code;
			public int m_sizeof_code; // size of code
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_initialized_data;
			public int m_sizeof_initialized_data; // size of initialized data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_uninitialized_data;
			public int m_sizeof_uninitialized_data; // size of uninitialized data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_entry;
			public int m_entry; // address of entry point
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_code_base;
			public int m_code_base; // address of code base
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_data_base;
			public int m_data_base; // address of data base
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_image_base;
			public int m_image_base; // address of image base
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_section_alignment;
			public int m_section_alignment; // section alignment
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_file_alignment;
			public int m_file_alignment; // file alignment
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_os_version_major;
			public short m_os_version_major; // operating system version [major]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_os_version_minor;
			public short m_os_version_minor; // operating system version [minor]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_image_version_major;
			public short m_image_version_major; // image version [major]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_image_version_minor;
			public short m_image_version_minor; // image version [minor]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_subsystem_version_major;
			public short m_subsystem_version_major; // subsystem version [major]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_subsystem_version_minor;
			public short m_subsystem_version_minor; // subsystem version [minor]
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_win32_version;
			public int m_win32_version; // win32 version
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_image;
			public int m_sizeof_image; // size of image
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_headers;
			public int m_sizeof_headers; // size of headers
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_checksum;
			public int m_checksum; // checksum
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_subsystem;
			public short m_subsystem; // subsystem
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_dll_characteristics;
			public short m_dll_characteristics; // dll characteristics
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_stack_reserve;
			public int m_sizeof_stack_reserve; // size of stack reserve
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_stack_commit;
			public int m_sizeof_stack_commit; // size of stack commit
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_heap_reserve;
			public int m_sizeof_heap_reserve; // size of heap reserve
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_heap_commit;
			public int m_sizeof_heap_commit; // size of heap commit
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_loader_flags;
			public int m_loader_flags; // loader flags
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_data_directories;
			public int m_data_directories; // data directories

			public static class image_data_directory // image data directory
			{
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_virtual_addr;
				public int m_virtual_addr; // virtual address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_size;
				public int m_size; // size
			}
			public image_data_directory[] m_image_data_directory = tangible.Arrays.initializeWithDefaultimage_data_directoryInstances(0x10);
		}
		public OptionalHeader m_OptionalHeader = new OptionalHeader();

		// PE section header
		public static class SectionHeader
		{
			public String m_name = new String(new char[8]); // name of section
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_virtual_size;
			public int m_virtual_size; // virtual size of segment
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_virtual_addr;
			public int m_virtual_addr; // virtual address of segment
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_sizeof_raw;
			public int m_sizeof_raw; // size of raw data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_raw_addr;
			public int m_raw_addr; // address of raw data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_relocations_addr;
			public int m_relocations_addr; // address of relocations
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_linenumbers_addr;
			public int m_linenumbers_addr; // address of line numbers
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_relocations;
			public short m_relocations; // number of relocations
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned short m_linenumbers;
			public short m_linenumbers; // number of linenumbers
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned long m_characteristics;
			public int m_characteristics; // characteristics for this segment
		}
		public SectionHeader m_SectionHeader;

		// array of section data
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char **m_bzSection;
		public byte[][] m_bzSection;

		// protected default constructor
		protected Exe()
		{
		}

		// constructor initialization
//C++ TO JAVA CONVERTER TODO TASK: The implementation of the following method could not be found:
//		void ConstructorInit();

		// return a modifiable pointer inside this structure that corresponds to a virtual address
//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
//ORIGINAL LINE: unsigned char *GetAddr(unsigned long x_dwVirtualAddress);
//C++ TO JAVA CONVERTER WARNING: Java has no equivalent to methods returning pointers to value types:
//ORIGINAL LINE: byte *GetAddr(uint x_dwVirtualAddress);
//C++ TO JAVA CONVERTER TODO TASK: The implementation of the following method could not be found:
//		byte GetAddr(uint x_dwVirtualAddress);

}


public class GlobalMembers
{
	// debug/retail XOR keys
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XOR_EP_DEBUG = 0x94859D4B;
	public static final int XOR_EP_DEBUG = (int)0x94859D4B; // Entry Point (Debug)
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XOR_EP_RETAIL = 0xA8FC57AB;
	public static final int XOR_EP_RETAIL = (int)0xA8FC57AB; // Entry Point (Retail)
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XOR_KT_DEBUG = 0xEFB1F152;
	public static final int XOR_KT_DEBUG = (int)0xEFB1F152; // Kernel Thunk (Debug)
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XOR_KT_RETAIL = 0x5B6D40B6;
	public static final int XOR_KT_RETAIL = 0x5B6D40B6; // Kernel Thunk (Retail)

	// game region flags for Xbe certificate
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_GAME_REGION_NA = 0x00000001;
	public static final int XBEIMAGE_GAME_REGION_NA = 0x00000001;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_GAME_REGION_JAPAN = 0x00000002;
	public static final int XBEIMAGE_GAME_REGION_JAPAN = 0x00000002;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_GAME_REGION_RESTOFWORLD = 0x00000004;
	public static final int XBEIMAGE_GAME_REGION_RESTOFWORLD = 0x00000004;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_GAME_REGION_MANUFACTURING = 0x80000000;
	public static final int XBEIMAGE_GAME_REGION_MANUFACTURING = (int)0x80000000;

	// media type flags for Xbe certificate
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_HARD_DISK = 0x00000001;
	public static final int XBEIMAGE_MEDIA_TYPE_HARD_DISK = 0x00000001;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_DVD_X2 = 0x00000002;
	public static final int XBEIMAGE_MEDIA_TYPE_DVD_X2 = 0x00000002;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_DVD_CD = 0x00000004;
	public static final int XBEIMAGE_MEDIA_TYPE_DVD_CD = 0x00000004;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_CD = 0x00000008;
	public static final int XBEIMAGE_MEDIA_TYPE_CD = 0x00000008;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_DVD_5_RO = 0x00000010;
	public static final int XBEIMAGE_MEDIA_TYPE_DVD_5_RO = 0x00000010;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_DVD_9_RO = 0x00000020;
	public static final int XBEIMAGE_MEDIA_TYPE_DVD_9_RO = 0x00000020;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_DVD_5_RW = 0x00000040;
	public static final int XBEIMAGE_MEDIA_TYPE_DVD_5_RW = 0x00000040;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_DVD_9_RW = 0x00000080;
	public static final int XBEIMAGE_MEDIA_TYPE_DVD_9_RW = 0x00000080;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_DONGLE = 0x00000100;
	public static final int XBEIMAGE_MEDIA_TYPE_DONGLE = 0x00000100;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_MEDIA_BOARD = 0x00000200;
	public static final int XBEIMAGE_MEDIA_TYPE_MEDIA_BOARD = 0x00000200;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_NONSECURE_HARD_DISK = 0x40000000;
	public static final int XBEIMAGE_MEDIA_TYPE_NONSECURE_HARD_DISK = 0x40000000;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_NONSECURE_MODE = 0x80000000;
	public static final int XBEIMAGE_MEDIA_TYPE_NONSECURE_MODE = (int)0x80000000;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: const unsigned long XBEIMAGE_MEDIA_TYPE_MEDIA_MASK = 0x00FFFFFF;
	public static final int XBEIMAGE_MEDIA_TYPE_MEDIA_MASK = 0x00FFFFFF;

	// OpenXDK logo bitmap (used by cxbe by default)
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: extern unsigned char OpenXDK[];
//C++ TO JAVA CONVERTER NOTE: 'extern' variable declarations are not required in Java:
	//extern byte OpenXDK[];
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: extern unsigned long dwSizeOfOpenXDK;
//C++ TO JAVA CONVERTER NOTE: 'extern' variable declarations are not required in Java:
	//extern uint dwSizeOfOpenXDK;

	// PE file/segment alignments : these must always both equal 0x0020

	// section characteristics

	// based relocation types

	// machine type(s)

	// subsystems

	// directory entries
	//      IMAGE_DIRECTORY_ENTRY_COPYRIGHT       7   // (X86 usage)

	// typical DOS stub
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: static unsigned char bzDOSStub[] = { 0x4D, 0x5A, 0x90, 0x00, 0x03, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB8, 0x00, 0x00, 0x00, 0x0E, 0x1F, 0xBA, 0x0E, 0x00, 0xB4, 0x09, 0xCD, 0x21, 0xB8, 0x01, 0x4C, 0xCD, 0x21, 0x54, 0x68, 0x69, 0x73, 0x20, 0x70, 0x72, 0x6F, 0x67, 0x72, 0x61, 0x6D, 0x20, 0x63, 0x61, 0x6E, 0x6E, 0x6F, 0x74, 0x20, 0x62, 0x65, 0x20, 0x72, 0x75, 0x6E, 0x20, 0x69, 0x6E, 0x20, 0x44, 0x4F, 0x53, 0x20, 0x6D, 0x6F, 0x64, 0x65, 0x2E, 0x0D, 0x0D, 0x0A, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x85, 0xE3, 0xB8, 0xDB, 0xC1, 0x82, 0xD6, 0x88, 0xC1, 0x82, 0xD6, 0x88, 0xC1, 0x82, 0xD6, 0x88, 0xC1, 0x82, 0xD7, 0x88, 0xC3, 0x82, 0xD6, 0x88, 0x3E, 0xA2, 0xD2, 0x88, 0xC2, 0x82, 0xD6, 0x88, 0x95, 0xA1, 0xE7, 0x88, 0xC0, 0x82, 0xD6, 0x88, 0x52, 0x69, 0x63, 0x68, 0xC1, 0x82, 0xD6, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
	public static byte[] bzDOSStub = {0x4D, 0x5A, 0x90, 0x00, 0x03, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB8, 0x00, 0x00, 0x00, 0x0E, 0x1F, 0xBA, 0x0E, 0x00, 0xB4, 0x09, 0xCD, 0x21, 0xB8, 0x01, 0x4C, 0xCD, 0x21, 0x54, 0x68, 0x69, 0x73, 0x20, 0x70, 0x72, 0x6F, 0x67, 0x72, 0x61, 0x6D, 0x20, 0x63, 0x61, 0x6E, 0x6E, 0x6F, 0x74, 0x20, 0x62, 0x65, 0x20, 0x72, 0x75, 0x6E, 0x20, 0x69, 0x6E, 0x20, 0x44, 0x4F, 0x53, 0x20, 0x6D, 0x6F, 0x64, 0x65, 0x2E, 0x0D, 0x0D, 0x0A, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x85, 0xE3, 0xB8, 0xDB, 0xC1, 0x82, 0xD6, 0x88, 0xC1, 0x82, 0xD6, 0x88, 0xC1, 0x82, 0xD6, 0x88, 0xC1, 0x82, 0xD7, 0x88, 0xC3, 0x82, 0xD6, 0x88, 0x3E, 0xA2, 0xD2, 0x88, 0xC2, 0x82, 0xD6, 0x88, 0x95, 0xA1, 0xE7, 0x88, 0xC0, 0x82, 0xD6, 0x88, 0x52, 0x69, 0x63, 0x68, 0xC1, 0x82, 0xD6, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


	// ******************************************************************
	// *
	// *    .,-:::::    .,::      .::::::::.    .,::      .:
	// *  ,;;;'````'    `;;;,  .,;;  ;;;'';;'   `;;;,  .,;; 
	// *  [[[             '[[,,[['   [[[__[[\.    '[[,,[['  
	// *  $$$              Y$$$P     $$""""Y$$     Y$$$P    
	// *  `88bo,__,o,    oP"``"Yo,  _88o,,od8P   oP"``"Yo,  
	// *    "YUMMMMMP",m"       "Mm,""YUMMMP" ,m"       "Mm,
	// *
	// *   Cxbx->Cxbx.h
	// *
	// *  This file is part of the Cxbx project.
	// *
	// *  Cxbx and Cxbe are free software; you can redistribute them
	// *  and/or modify them under the terms of the GNU General Public
	// *  License as published by the Free Software Foundation; either
	// *  version 2 of the license, or (at your option) any later version.
	// *
	// *  This program is distributed in the hope that it will be useful,
	// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
	// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	// *  GNU General Public License for more details.
	// *
	// *  You should have recieved a copy of the GNU General Public License
	// *  along with this program; see the file COPYING.
	// *  If not, write to the Free Software Foundation, Inc.,
	// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
	// *
	// *  (c) 2002-2003 Aaron Robinson <caustik@caustik.com>
	// *
	// *  All rights reserved
	// *
	// ******************************************************************


	/*! round dwValue to the nearest multiple of dwMult */
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: static unsigned long RoundUp(unsigned long dwValue, unsigned long dwMult)
	public static int RoundUp(int dwValue, int dwMult)
	{
		if (dwMult == 0)
		{
			return dwValue;
		}

		return dwValue - (dwValue-1) % dwMult + (dwMult - 1);
	}

	// better time
	public static String BetterTime(tangible.RefObject<String> x_ctime)
	{
		int v = 0;

		for (v = 0;x_ctime.argValue.charAt(v) != '\n';v++)
		{
			;
		}

		x_ctime.argValue.charAt(v) = '\0';

		return x_ctime.argValue;
	}
}

final class DefineConstants
{
//C++ TO JAVA CONVERTER TODO TASK: The following #define constant was defined in different ways:
	public static final String _CXBX_VERSION = "0.8.0";
	public static final String _CXBX_VERSION = "0.8.0-Trace";
	public static final int MAXIMUM_XBOX_THREADS = 256;
	public static final int PE_FILE_ALIGN = 0x00000020;
	public static final int PE_SEGM_ALIGN = 0x00000020;
	public static final int IMAGE_SCN_CNT_CODE = 0x00000020;
	public static final int IMAGE_SCN_CNT_INITIALIZED_DATA = 0x00000040;
	public static final int IMAGE_SCN_CNT_UNINITIALIZED_DATA = 0x00000080;
	public static final int IMAGE_SCN_MEM_DISCARDABLE = 0x02000000;
	public static final int IMAGE_SCN_MEM_NOT_CACHED = 0x04000000;
	public static final int IMAGE_SCN_MEM_NOT_PAGED = 0x08000000;
	public static final int IMAGE_SCN_MEM_SHARED = 0x10000000;
	public static final int IMAGE_SCN_MEM_EXECUTE = 0x20000000;
	public static final int IMAGE_SCN_MEM_READ = 0x40000000;
	public static final int IMAGE_SCN_MEM_WRITE = 0x80000000;
	public static final int IMAGE_REL_BASED_ABSOLUTE = 0;
	public static final int IMAGE_REL_BASED_HIGH = 1;
	public static final int IMAGE_REL_BASED_LOW = 2;
	public static final int IMAGE_REL_BASED_HIGHLOW = 3;
	public static final int IMAGE_REL_BASED_HIGHADJ = 4;
	public static final int IMAGE_REL_BASED_MIPS_JMPADDR = 5;
	public static final int IMAGE_REL_BASED_MIPS_JMPADDR16 = 9;
	public static final int IMAGE_REL_BASED_IA64_IMM64 = 9;
	public static final int IMAGE_REL_BASED_DIR64 = 10;
	public static final int IMAGE_FILE_MACHINE_I386 = 0x014c; // Intel 386
	public static final int IMAGE_SUBSYSTEM_UNKNOWN = 0;
	public static final int IMAGE_SUBSYSTEM_NATIVE = 1;
	public static final int IMAGE_SUBSYSTEM_WINDOWS_GUI = 2;
	public static final int IMAGE_SUBSYSTEM_WINDOWS_CUI = 3;
	public static final int IMAGE_SUBSYSTEM_OS2_CUI = 5;
	public static final int IMAGE_SUBSYSTEM_POSIX_CUI = 7;
	public static final int IMAGE_SUBSYSTEM_NATIVE_WINDOWS = 8;
	public static final int IMAGE_SUBSYSTEM_WINDOWS_CE_GUI = 9;
	public static final int IMAGE_DIRECTORY_ENTRY_EXPORT = 0; // Export Directory
	public static final int IMAGE_DIRECTORY_ENTRY_IMPORT = 1; // Import Directory
	public static final int IMAGE_DIRECTORY_ENTRY_RESOURCE = 2; // Resource Directory
	public static final int IMAGE_DIRECTORY_ENTRY_EXCEPTION = 3; // Exception Directory
	public static final int IMAGE_DIRECTORY_ENTRY_SECURITY = 4; // Security Directory
	public static final int IMAGE_DIRECTORY_ENTRY_BASERELOC = 5; // Base Relocation Table
	public static final int IMAGE_DIRECTORY_ENTRY_DEBUG = 6; // Debug Directory
	public static final int IMAGE_DIRECTORY_ENTRY_ARCHITECTURE = 7; // Architecture Specific Data
	public static final int IMAGE_DIRECTORY_ENTRY_GLOBALPTR = 8; // RVA of GP
	public static final int IMAGE_DIRECTORY_ENTRY_TLS = 9; // TLS Directory
	public static final int IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG = 10; // Load Configuration Directory
	public static final int IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11; // Bound Import Directory in headers
	public static final int IMAGE_DIRECTORY_ENTRY_IAT = 12; // Import Address Table
	public static final int IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT = 13; // Delay Load Import Descriptors
	public static final int IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR = 14; // COM Runtime descriptor
}

package tangible;

//----------------------------------------------------------------------------------------
//	Copyright © 2006 - 2016 Tangible Software Solutions Inc.
//	This class can be used by anyone provided that the copyright notice remains intact.
//
//	This class provides the ability to initialize array elements with the default
//	constructions for the array type.
//----------------------------------------------------------------------------------------
public final class Arrays
{
	public static SectionHeader[] initializeWithDefaultSectionHeaderInstances(int length)
	{
		SectionHeader[] array = new SectionHeader[length];
		for (int i = 0; i < length; i++)
		{
			array[i] = new SectionHeader();
		}
		return array;
	}

	public static LibraryVersion[] initializeWithDefaultLibraryVersionInstances(int length)
	{
		LibraryVersion[] array = new LibraryVersion[length];
		for (int i = 0; i < length; i++)
		{
			array[i] = new LibraryVersion();
		}
		return array;
	}

	public static image_data_directory[] initializeWithDefaultimage_data_directoryInstances(int length)
	{
		image_data_directory[] array = new image_data_directory[length];
		for (int i = 0; i < length; i++)
		{
			array[i] = new image_data_directory();
		}
		return array;
	}
}

package tangible;

//----------------------------------------------------------------------------------------
//	Copyright © 2006 - 2016 Tangible Software Solutions Inc.
//	This class can be used by anyone provided that the copyright notice remains intact.
//
//	This class is used to simulate the ability to pass arguments by reference in Java.
//----------------------------------------------------------------------------------------
public final class RefObject<T>
{
	public T argValue;
	public RefObject(T refArg)
	{
		argValue = refArg;
	}
}

package tangible;

//----------------------------------------------------------------------------------------
//	Copyright © 2006 - 2016 Tangible Software Solutions Inc.
//	This class can be used by anyone provided that the copyright notice remains intact.
//
//	This class provides the ability to simulate various classic C string functions
//	which don't have exact equivalents in the Java framework.
//----------------------------------------------------------------------------------------
public final class StringFunctions
{
	//------------------------------------------------------------------------------------
	//	This method allows replacing a single character in a string, to help convert
	//	C++ code where a single character in a character array is replaced.
	//------------------------------------------------------------------------------------
	public static String changeCharacter(String sourceString, int charIndex, char changeChar)
	{
		return (charIndex > 0 ? sourceString.substring(0, charIndex) : "")
			+ Character.toString(changeChar) + (charIndex < sourceString.length() - 1 ? sourceString.substring(charIndex + 1) : "");
	}

	//------------------------------------------------------------------------------------
	//	This method simulates the classic C string function 'isxdigit' (and 'iswxdigit').
	//------------------------------------------------------------------------------------
	public static boolean isXDigit(char character)
	{
		if (Character.isDigit(character))
			return true;
		else if ("ABCDEFabcdef".indexOf(character) > -1)
			return true;
		else
			return false;
	}

	//------------------------------------------------------------------------------------
	//	This method simulates the classic C string function 'strchr' (and 'wcschr').
	//------------------------------------------------------------------------------------
	public static String strChr(String stringToSearch, char charToFind)
	{
		int index = stringToSearch.indexOf(charToFind);
		if (index > -1)
			return stringToSearch.substring(index);
		else
			return null;
	}

	//------------------------------------------------------------------------------------
	//	This method simulates the classic C string function 'strrchr' (and 'wcsrchr').
	//------------------------------------------------------------------------------------
	public static String strRChr(String stringToSearch, char charToFind)
	{
		int index = stringToSearch.lastIndexOf(charToFind);
		if (index > -1)
			return stringToSearch.substring(index);
		else
			return null;
	}

	//------------------------------------------------------------------------------------
	//	This method simulates the classic C string function 'strstr' (and 'wcsstr').
	//------------------------------------------------------------------------------------
	public static String strStr(String stringToSearch, String stringToFind)
	{
		int index = stringToSearch.indexOf(stringToFind);
		if (index > -1)
			return stringToSearch.substring(index);
		else
			return null;
	}

	//------------------------------------------------------------------------------------
	//	This method simulates the classic C string function 'strtok' (and 'wcstok').
	//------------------------------------------------------------------------------------
	private static String activeString;
	private static int activePosition;
	public static String strTok(String stringToTokenize, String delimiters)
	{
		if (stringToTokenize != null)
		{
			activeString = stringToTokenize;
			activePosition = -1;
		}

		//the stringToTokenize was never set:
		if (activeString == null)
			return null;

		//all tokens have already been extracted:
		if (activePosition == activeString.length())
			return null;

		//bypass delimiters:
		activePosition++;
		while (activePosition < activeString.length() && delimiters.indexOf(activeString.charAt(activePosition)) > -1)
		{
			activePosition++;
		}

		//only delimiters were left, so return null:
		if (activePosition == activeString.length())
			return null;

		//get starting position of string to return:
		int startingPosition = activePosition;

		//read until next delimiter:
		do
		{
			activePosition++;
		} while (activePosition < activeString.length() && delimiters.indexOf(activeString.charAt(activePosition)) == -1);

		return activeString.substring(startingPosition, activePosition);
	}
}