public class GlobalMembers
{


// show program usage
	// ******************************************************************
	// *
	// *    .,-:::::    .,::      .::::::::.    .,::      .:
	// *  ,;;;'````'    `;;;,  .,;;  ;;;'';;'   `;;;,  .,;; 
	// *  [[[             '[[,,[['   [[[__[[\.    '[[,,[['  
	// *  $$$              Y$$$P     $$""""Y$$     Y$$$P    
	// *  `88bo,__,o,    oP"``"Yo,  _88o,,od8P   oP"``"Yo,  
	// *    "YUMMMMMP",m"       "Mm,""YUMMMP" ,m"       "Mm,
	// *
	// *   Cxbx->Standard->Cxbe->Main.cpp
	// *
	// *  This file is part of the Cxbx project.
	// *
	// *  Cxbx and Cxbe are free software; you can redistribute them
	// *  and/or modify them under the terms of the GNU General Public
	// *  License as published by the Free Software Foundation; either
	// *  version 2 of the license, or (at your option) any later version.
	// *
	// *  This program is distributed in the hope that it will be useful,
	// *  but WITHOUT ANY WARRANTY; without even the implied warranty of
	// *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	// *  GNU General Public License for more details.
	// *
	// *  You should have recieved a copy of the GNU General Public License
	// *  along with this program; see the file COPYING.
	// *  If not, write to the Free Software Foundation, Inc.,
	// *  59 Temple Place - Suite 330, Bostom, MA 02111-1307, USA.
	// *
	// *  (c) 2002-2003 Aaron Robinson <caustik@caustik.com>
	// *
	// *  All rights reserved
	// *
	// ******************************************************************



	// static global(s)
	public static void ShowUsage()
	{
		System.out.print("CXBE XBE->EXE (XBox->Win32) Relinker (CXBX Core Version " DefineConstants._CXBX_VERSION ")\n" + "Copyright (C) Aaron Robinson 2002-2003. All rights reserved.\n" + "\n" + "Usage : cxbe [options] [exefile]\n" + "\n" + "Options :\n" + "\n" + "  -OUT:filename\n" + "  -DUMPINFO:filename\n" + "  -TITLE:title\n" + "  -MODE:{debug|retail}\n");
	}

// convert string to upper case
//C++ TO JAVA CONVERTER TODO TASK: Pointer arithmetic is detected on the parameter 'str', so pointers on this parameter are left unchanged:
	public static void MakeUpper(byte * str)
	{
		while (*str != '\0')
		{
			if (*str >= 'a' && *str <= 'z')
			{
				*str = str - ('a' - 'A');
			}

			str = str.Substring(1);
		}
	}

	// program entry point
	public static int Main(int argc, String[] args)
	{
		byte[] szErrorMessage = new byte[266];
		byte[] szExeFilename = new byte[266];
		byte[] szXbeFilename = new byte[266];
		byte[] szDumpFilename = new byte[266];
		String szXbeTitle = "Untitled";
		boolean bRetail = true;

		// parse command line
		for (int v = 1;v < argc;v++)
		{
			String szOption = 0;
			String szParam = 0;
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: unsigned int dwParamSize = 0;
			int dwParamSize = 0;

			// if this isn't an option, it must be the Exe file
			if (args[v].charAt(0) != '-')
			{
				szExeFilename = String.valueOf(args[v]).substring(0, 265);
				continue;
			}

			{
			// locate the colon and seperate option / parameters
	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: unsigned int dwColon = (unsigned int)-1;
				int dwColon = (int)-1;

	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: for(unsigned int c=1;args[v][c] != 0;c++)
				for (int c = 1;args[v].charAt(c) != 0;c++)
				{
					if (args[v].charAt(c) == ':')
					{
						dwColon = c;
						break;
					}
				}

	//C++ TO JAVA CONVERTER WARNING: Unsigned integer types have no direct equivalent in Java:
	//ORIGINAL LINE: if(dwColon == (unsigned int)-1)
				if (dwColon == (int)-1)
				{
					szErrorMessage = "Command line format error";
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}

				args[v].charAt(dwColon) = '\0';

				szOption = args[v].charAt(1);
				szParam = args[v].charAt(dwColon + 1);

				while (szParam.charAt(dwParamSize) != 0)
				{
					dwParamSize++;
				}
		}

		{
			// interpret the current switch
				byte[] szOptionU = new byte[266];
				byte[] szParamU = new byte[266];

				szOptionU = szOption.substring(0, 265);
				szParamU = szParam.substring(0, 265);

				MakeUpper(szOptionU);
				MakeUpper(szParamU);

				if (strcmp(szOptionU, "OUT") == 0)
				{
					szXbeFilename = szParam;
				}
				else if (strcmp(szOptionU, "DUMPINFO") == 0)
				{
					szDumpFilename = szParam;
				}
				else if (strcmp(szOptionU, "TITLE") == 0)
				{
					if (dwParamSize > 256)
					{
						System.out.print("WARNING: Title too long, using default title\n");
					}
					else
					{
						szXbeTitle = szParam;
					}
				}
				else if (strcmp(szOptionU, "MODE") == 0)
				{
					if (strcmp(szParamU, "RETAIL") == 0)
					{
						bRetail = true;
					}
					else if (strcmp(szParamU, "DEBUG") == 0)
					{
						bRetail = false;
					}
					else
					{
						szErrorMessage = "invalid MODE";
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}
				}
				else
				{
					String szBuffer = new String(new char[255]);
					szBuffer = String.format("Unrecognized command : %s", szOption);
					szErrorMessage = szBuffer;
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
					goto cleanup;
				}
		}
		}

		// verify we recieved the required parameters
		if (szExeFilename[0] == '\0')
		{
			ShowUsage();
			return 1;
		}

		// if we don't have an Xbe filename, generate one from szExeFilename
		if (szXbeFilename[0] == '\0')
		{
			szXbeFilename = szExeFilename;

			String szFilename = szXbeFilename[0];

			{
			// locate last \ or / (if there are any)
				for (int c = 0;szXbeFilename[c] != 0;c++)
				{
					if (szXbeFilename[c] == '\\' || szXbeFilename[c] == '/')
					{
						szFilename = szXbeFilename[c + 1];
					}
				}
			}

			{
			// locate and remove last . (if there are any)
				String szWorkingU = new String(new char[266]);

				String szWorking = szFilename;

				szWorkingU = szWorking.substring(0, 265);

				for (int c = 0;szFilename.charAt(c) != 0;c++)
				{
					if (szFilename.charAt(c) == '.')
					{
						szWorking = szFilename.charAt(c);
					}
				}

				MakeUpper(szWorking);

				if (strcmp(szWorkingU, ".exe") == 0)
				{
					szWorking = ".xbe";
				}
				else
				{
					szXbeFilename += ".xbe";
				}
		}
		}

		{
		// open and convert Exe file
			Exe ExeFile = new Exe(szExeFilename);

			if (ExeFile.GetError() != 0)
			{
				szErrorMessage = ExeFile.GetError();
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
				goto cleanup;
			}

			Xbe XbeFile = new Xbe(ExeFile, szXbeTitle, bRetail);

			if (XbeFile.GetError() != 0)
			{
				szErrorMessage = XbeFile.GetError();
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
				goto cleanup;
			}

			if (szDumpFilename[0] != 0)
			{
				FILE outfile = fopen(szDumpFilename, "wt");
				XbeFile.DumpInformation(outfile);
				fclose(outfile);

				if (XbeFile.GetError() != 0)
				{
					if (XbeFile.IsFatal())
					{
						szErrorMessage = XbeFile.GetError();
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
						goto cleanup;
					}
					else
					{
						System.out.printf("DUMPINFO -> Warning: %s\n", XbeFile.GetError());
						XbeFile.ClearError();
					}
				}
			}

			XbeFile.Export(szXbeFilename);

			if (XbeFile.GetError() != 0)
			{
				szErrorMessage = XbeFile.GetError();
//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
				goto cleanup;
			}
	}

//C++ TO JAVA CONVERTER TODO TASK: There are no gotos or labels in Java:
	cleanup:

		if (szErrorMessage[0] != 0)
		{
			ShowUsage();

			System.out.print("\n");
			System.out.printf(" *  Error : %s\n", szErrorMessage);

			return 1;
		}

	}
}

final class DefineConstants
{
//C++ TO JAVA CONVERTER TODO TASK: The following #define constant was defined in different ways:
	public static final String _CXBX_VERSION = "0.8.0";
	public static final String _CXBX_VERSION = "0.8.0-Trace";
	public static final int MAXIMUM_XBOX_THREADS = 256;
	public static final int PE_FILE_ALIGN = 0x00000020;
	public static final int PE_SEGM_ALIGN = 0x00000020;
	public static final int IMAGE_SCN_CNT_CODE = 0x00000020;
	public static final int IMAGE_SCN_CNT_INITIALIZED_DATA = 0x00000040;
	public static final int IMAGE_SCN_CNT_UNINITIALIZED_DATA = 0x00000080;
	public static final int IMAGE_SCN_MEM_DISCARDABLE = 0x02000000;
	public static final int IMAGE_SCN_MEM_NOT_CACHED = 0x04000000;
	public static final int IMAGE_SCN_MEM_NOT_PAGED = 0x08000000;
	public static final int IMAGE_SCN_MEM_SHARED = 0x10000000;
	public static final int IMAGE_SCN_MEM_EXECUTE = 0x20000000;
	public static final int IMAGE_SCN_MEM_READ = 0x40000000;
	public static final int IMAGE_SCN_MEM_WRITE = 0x80000000;
	public static final int IMAGE_REL_BASED_ABSOLUTE = 0;
	public static final int IMAGE_REL_BASED_HIGH = 1;
	public static final int IMAGE_REL_BASED_LOW = 2;
	public static final int IMAGE_REL_BASED_HIGHLOW = 3;
	public static final int IMAGE_REL_BASED_HIGHADJ = 4;
	public static final int IMAGE_REL_BASED_MIPS_JMPADDR = 5;
	public static final int IMAGE_REL_BASED_MIPS_JMPADDR16 = 9;
	public static final int IMAGE_REL_BASED_IA64_IMM64 = 9;
	public static final int IMAGE_REL_BASED_DIR64 = 10;
	public static final int IMAGE_FILE_MACHINE_I386 = 0x014c; // Intel 386
	public static final int IMAGE_SUBSYSTEM_UNKNOWN = 0;
	public static final int IMAGE_SUBSYSTEM_NATIVE = 1;
	public static final int IMAGE_SUBSYSTEM_WINDOWS_GUI = 2;
	public static final int IMAGE_SUBSYSTEM_WINDOWS_CUI = 3;
	public static final int IMAGE_SUBSYSTEM_OS2_CUI = 5;
	public static final int IMAGE_SUBSYSTEM_POSIX_CUI = 7;
	public static final int IMAGE_SUBSYSTEM_NATIVE_WINDOWS = 8;
	public static final int IMAGE_SUBSYSTEM_WINDOWS_CE_GUI = 9;
	public static final int IMAGE_DIRECTORY_ENTRY_EXPORT = 0; // Export Directory
	public static final int IMAGE_DIRECTORY_ENTRY_IMPORT = 1; // Import Directory
	public static final int IMAGE_DIRECTORY_ENTRY_RESOURCE = 2; // Resource Directory
	public static final int IMAGE_DIRECTORY_ENTRY_EXCEPTION = 3; // Exception Directory
	public static final int IMAGE_DIRECTORY_ENTRY_SECURITY = 4; // Security Directory
	public static final int IMAGE_DIRECTORY_ENTRY_BASERELOC = 5; // Base Relocation Table
	public static final int IMAGE_DIRECTORY_ENTRY_DEBUG = 6; // Debug Directory
	public static final int IMAGE_DIRECTORY_ENTRY_ARCHITECTURE = 7; // Architecture Specific Data
	public static final int IMAGE_DIRECTORY_ENTRY_GLOBALPTR = 8; // RVA of GP
	public static final int IMAGE_DIRECTORY_ENTRY_TLS = 9; // TLS Directory
	public static final int IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG = 10; // Load Configuration Directory
	public static final int IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11; // Bound Import Directory in headers
	public static final int IMAGE_DIRECTORY_ENTRY_IAT = 12; // Import Address Table
	public static final int IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT = 13; // Delay Load Import Descriptors
	public static final int IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR = 14; // COM Runtime descriptor
}